//FMT$LOAD JOB (FMT),'RELOAD FMT SOURCE',CLASS=A,MSGCLASS=A             00010000
//IEBUPDTE EXEC PGM=IEBUPDTE,REGION=1024K,PARM=NEW                      00020000
//SYSUT2   DD  DSN=JAY01.FORMAT.SOURCE,DISP=(,CATLG,DELETE),            00030000
//             UNIT=3330,VOL=SER=JAY001,                                00040000
//             SPACE=(CYL,(3,,10)),                                     00050000
//             DCB=(RECFM=FB,LRECL=80,BLKSIZE=3120)                     00060000
//SYSPRINT DD  DUMMY                                                    00070000
//SYSIN    DD  DATA,DLM='%%'                                            00080000
./       ADD   NAME=$INDEX
This is the source/jobstream dataset for the Format/Edit routines.      00010000
$INDEX   - this text                                                    00020000
EYEC     - ALC macro                                                    00030000
FMT$ASM  - jobstream to assemble/link the routines                      00040000
FMT$INST - jobstream to allocate load library & submit FMT$ASM          00050000
FMT$IVP  - jobstream to run the installation verification program       00060000
FMTIVP   - COBOL Installation Verification program                      00070000
IFMTFILL - input field must be filled                                   00080000
IFMTFLPT - input field floating point format                            00090000
IFMTHEX  - input field hex digits                                       00100000
IFMTLJST - input field left justify                                     00110000
IFMTMASK - input field extract using mask                               00120000
IFMTNIB  - input field no imbedded blanks                               00130000
OFMTHEX  - output field printable hex digits                            00140000
OFMTMONY - output field monetary field as words                         00150000
./       ADD   NAME=EYEC
         MACRO
         EYEC  &DESC
EC$$B    B     EC$$L(,R15)             BRANCH AROUND EYECATCHER
         DC    AL1(EC$$E-EC$$V)        LENGTH OF VERSION INFO
EC$$V    DC    C'&SYSECT '             CSECT NAME
         DC    C'&SYSDATE &SYSTIME - '  WHEN ASSEMBLED
         AIF   (T'&DESC EQ 'O').NODESC
         DC    C&DESC
.NODESC  ANOP
EC$$E    DS    0H
EC$$L    EQU   (*-EC$$B)               LENGTH OF EYECATCHER FIELDS
         MEND
./       ADD   NAME=FMT$ASM
//FMT$ASM  JOB (FMT),'ASSEMBLE FMT',CLASS=A,MSGCLASS=X,COND=(0,NE)      00010000
//ALLOC   EXEC PGM=IEFBR14                                              00020000
//LLIB     DD  DSN=JAY01.FORMAT.LOADLIB,DISP=(NEW,CATLG,DELETE),        00030000
//             UNIT=3330,VOL=SER=JAY001,                                00040000
//             SPACE=(TRK,(38,19,10)),DCB=(SYS1.LINKLIB)                00050000
//*****************************************************************     00060000
//IFILL EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                 00070000
//             MAC1='JAY01.FORMAT.SOURCE',                              00080000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00090000
//ASM.SYSPRINT DD SYSOUT=*                                              00100000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(IFMTFILL)               00110000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00120000
//LKED.SYSPRINT DD SYSOUT=*                                             00130000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00140000
//LKED.SYSIN DD *                                                       00150000
  NAME IFMTFILL(R)                                                      00160000
//*****************************************************************     00170000
//IFLPT EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                 00180000
//             MAC1='JAY01.FORMAT.SOURCE',                              00190000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00200000
//ASM.SYSPRINT DD SYSOUT=*                                              00210000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(IFMTFLPT)               00220000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00230000
//LKED.SYSPRINT DD SYSOUT=*                                             00240000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00250000
//LKED.SYSIN DD *                                                       00260000
  NAME IFMTFLPT(R)                                                      00270000
//*****************************************************************     00280000
//IHEX EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                  00290000
//             MAC1='JAY01.FORMAT.SOURCE',                              00300000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00310000
//ASM.SYSPRINT DD SYSOUT=*                                              00320000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(IFMTHEX)                00330000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00340000
//LKED.SYSPRINT DD SYSOUT=*                                             00350000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00360000
//LKED.SYSIN DD *                                                       00370000
  NAME IFMTHEX(R)                                                       00380000
//*****************************************************************     00390000
//ILJST EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                 00400000
//             MAC1='JAY01.FORMAT.SOURCE',                              00410000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00420000
//ASM.SYSPRINT DD SYSOUT=*                                              00430000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(IFMTLJST)               00440000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00450000
//LKED.SYSPRINT DD SYSOUT=*                                             00460000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00470000
//LKED.SYSIN DD *                                                       00480000
  NAME IFMTLJST(R)                                                      00490000
//*****************************************************************     00500000
//IMASK EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                 00510000
//             MAC1='JAY01.FORMAT.SOURCE',                              00520000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00530000
//ASM.SYSPRINT DD SYSOUT=*                                              00540000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(IFMTMASK)               00550000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00560000
//LKED.SYSPRINT DD SYSOUT=*                                             00570000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00580000
//LKED.SYSIN DD *                                                       00590000
  NAME IFMTMASK(R)                                                      00600000
//*****************************************************************     00610000
//INIB EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                  00620000
//             MAC1='JAY01.FORMAT.SOURCE',                              00630000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00640000
//ASM.SYSPRINT DD SYSOUT=*                                              00650000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(IFMTNIB)                00660000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00670000
//LKED.SYSPRINT DD SYSOUT=*                                             00680000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00690000
//LKED.SYSIN DD *                                                       00700000
  NAME IFMTNIB(R)                                                       00710000
//*****************************************************************     00720000
//OHEX EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                  00730000
//             MAC1='JAY01.FORMAT.SOURCE',                              00740000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00750000
//ASM.SYSPRINT DD SYSOUT=*                                              00760000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(OFMTHEX)                00770000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00780000
//LKED.SYSPRINT DD SYSOUT=*                                             00790000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00800000
//LKED.SYSIN DD *                                                       00810000
  NAME OFMTHEX(R)                                                       00820000
//*****************************************************************     00830000
//OMONY EXEC ASMFCL,PARM.ASM='LIST,OBJECT,NODECK,RENT',                 00840000
//             MAC1='JAY01.FORMAT.SOURCE',                              00850000
//             PARM.LKED='LIST,XREF,MAP,RENT,REUS'                      00860000
//ASM.SYSPRINT DD SYSOUT=*                                              00870000
//ASM.SYSIN DD DISP=SHR,DSN=JAY01.FORMAT.SOURCE(OFMTMONY)               00880000
//LKED.SYSLMOD DD DSN=JAY01.FORMAT.LOADLIB,DISP=OLD                     00890000
//LKED.SYSPRINT DD SYSOUT=*                                             00900000
//LKED.SYSLIB DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                      00910000
//LKED.SYSIN DD *                                                       00920000
  NAME OFMTMONY(R)                                                      00930000
//*****************************************************************     00940000
//                                                                      00950000
./       ADD   NAME=FMT$INST
//FMT$INST JOB (FMT),'INSTALL FMT',CLASS=A,MSGCLASS=A                   00010000
//DELETE  EXEC PGM=IDCAMS,REGION=4096K                                  00020000
//SYSPRINT DD  SYSOUT=*                                                 00030000
//SYSIN    DD  *                                                        00040000
                                                                        00050000
  /* DELETE FORMAT ROUTINES LOAD LIBRARY                    */          00060000
                                                                        00070000
  DELETE (JAY01.FORMAT.LOADLIB)                                -        00080000
         NONVSAM SCRATCH PURGE                                          00090000
                                                                        00100000
  SET MAXCC=0                                                           00110000
  SET LASTCC=0                                                          00120000
                                                                        00130000
//*****************************************************************     00140000
//SUBMIT  EXEC PGM=IEBGENER                                             00150000
//SYSIN    DD  DUMMY                                                    00160000
//SYSPRINT DD  SYSOUT=*                                                 00170000
//SYSUT1   DD  DSN=JAY01.FORMAT.SOURCE(FMT$ASM),DISP=SHR                00180000
//SYSUT2   DD  SYSOUT=(A,INTRDR)                                        00190000
//                                                                      00200000
./       ADD   NAME=FMT$IVP
//FMT$IVP JOB (FMT),'FMT VERIFY',CLASS=A,MSGCLASS=A                     00220000
//FMTIVP EXEC COBUCLG,REGION.COB=4096K,                                 00230000
//             PARM.COB='LOAD,LIST,DMAP,SIZE=2048K,BUF=1024K'           00240000
//COB.SYSIN DD DSN=JAY01.FORMAT.SOURCE(FMTIVP),DISP=SHR                 00250000
//LKED.SYSLIB DD                                                        00260000
//         DD DSN=JAY01.FORMAT.LOADLIB,DISP=SHR                         00270000
//GO.TESTDATA DD DSN=JAY01.FORMAT.SOURCE(FMTIVPD),DISP=SHR              00280000
//GO.REPORT DD SYSOUT=*                                                 00290000
//                                                                      00300000
./       ADD   NAME=FMTIVP
000100 IDENTIFICATION DIVISION.                                         00010000
000200 PROGRAM-ID. FMTIVP.                                              00020000
000300 AUTHOR. JAY MOSELEY.                                             00030000
000400 DATE-WRITTEN. JULY, 2000.                                        00040000
000500 DATE-COMPILED.                                                   00050000
000600                                                                  00060000
000700* ************************************************************* * 00070000
000800* THE PURPOSE OF THIS PROGRAM IS TO VERIFY THE FUNCTIONALITY    * 00080000
000900* OF THE 370 ASSEMBLER FIELD INPUT/OUTPUT FORMATTING ROUTINES   * 00090000
001000* AFTER THEIR INSTALLATION UNDER HERCULES/MVT.                  * 00100000
001100* ************************************************************* * 00110000
001200/                                                                 00120000
001300 ENVIRONMENT DIVISION.                                            00130000
001400 CONFIGURATION SECTION.                                           00140000
001500 SPECIAL-NAMES.                                                   00150000
001600     C01 IS TO-FIRST-LINE.                                        00160000
001700 INPUT-OUTPUT SECTION.                                            00170000
001800 FILE-CONTROL.                                                    00180000
001900     SELECT DATA-FILE                                             00190000
002000         ASSIGN TO UT-S-TESTDATA.                                 00200000
002100                                                                  00210000
002200     SELECT PRINT-FILE                                            00220000
002300         ASSIGN TO UR-S-REPORT.                                   00230000
002400 DATA DIVISION.                                                   00240000
002500                                                                  00250000
002600 FILE SECTION.                                                    00260000
002700 FD  DATA-FILE                                                    00270000
002800     LABEL RECORDS ARE STANDARD                                   00280000
002850     BLOCK CONTAINS 0 RECORDS                                     00290000
002900     RECORD CONTAINS 80 CHARACTERS                                00300000
003000     DATA RECORD IS DATA-RECD.                                    00310000
003100 01  DATA-RECORD                 PIC X(80).                       00320000
003200                                                                  00330000
003300 FD  PRINT-FILE                                                   00340000
003400     LABEL RECORDS ARE OMITTED                                    00350000
003500     RECORD CONTAINS 133 CHARACTERS                               00360000
003600     DATA RECORD IS PRINT-RECD.                                   00370000
003700 01  PRINT-RECORD               PIC X(133).                       00380000
003800/                                                                 00390000
003900 WORKING-STORAGE SECTION.                                         00400000
004000                                                                  00410000
004100* ************************************************************* * 00420000
004200* THESE ARE PROGRAM CONTROL SWITCHES AND MISCELLANEOUS FIELDS.  * 00430000
004300* ************************************************************* * 00440000
004400 01  PROGRAM-CONTROL-FIELDS.                                      00450000
004500     02  END-OF-DATA-SWITCH      PIC X(1) VALUE 'N'.              00460000
004600         88  END-OF-DATA         VALUE 'Y'.                       00470000
004700     02  SYSTEM-TIME             PIC 9(8).                        00480000
004800     02  FILLER                  REDEFINES SYSTEM-TIME.           00490000
004900         03  SYSTEM-TIME-SHORT   PIC 9(4).                        00500000
005000         03  FILLER              PIC 9(4).                        00510000
005100     02  PAGE-COUNT              PIC 999 VALUE ZERO.              00520000
005200     02  LINE-COUNT              PIC 99  VALUE 99.                00530000
005300     02  PAGE-SIZE               PIC 99  VALUE 42.                00540000
005400                                                                  00550000
005500     02  UNFORMATTED-GDATE       PIC X(8).                        00560000
005600     02  FILLER                  REDEFINES UNFORMATTED-GDATE.     00570000
005700         03  UNFORMATTED-GMONTH  PIC 9(2).                        00580000
005800         03  UNFORMATTED-GDAY    PIC 9(2).                        00590000
005900         03  UNFORMATTED-GYEAR   PIC 9(4).                        00600000
006000                                                                  00610000
006100     02  FORMATTED-GDATE         PIC X(10).                       00620000
006200     02  FILLER                  REDEFINES FORMATTED-GDATE.       00630000
006300         03  FORMATTED-GMONTH    PIC Z9.                          00640000
006400         03  FILLER              PIC X(1).                        00650000
006500         03  FORMATTED-GDAY      PIC 9(2).                        00660000
006600         03  FILLER              PIC X(1).                        00670000
006700         03  FORMATTED-GYEAR     PIC 9(4).                        00680000
006800                                                                  00690000
006900* ************************************************************* * 00700000
007000* FOLLOWING ARE SPECIFIC RECORD DESCRIPTIONS USED TO REDEFINE   * 00710000
007100* THE TEST DATA INPUT RECORD FOR EACH OF THE 12 ROUTINES.       * 00720000
007200* ************************************************************* * 00730000
007300 01  TEST-RECORD.                                                 00740000
007400     02  TR-IDENTIFICATION       PIC X(4).                        00750000
007500     02  FILLER                  PIC X(1).                        00760000
007600     02  TR-DATA                 PIC X(75).                       00770000
007700                                                                  00780000
007800     02  FILLER                  REDEFINES TR-DATA.               00790000
007900         03  TR-FILL-DATA        PIC X(12).                       00800000
008000         03  FILLER              PIC X(1).                        00810000
008100         03  TR-FILL-SIZE        PIC 9(2).                        00820000
008200         03  FILLER              PIC X(60).                       00830000
008300                                                                  00840000
008400     02  FILLER                  REDEFINES TR-DATA.               00850000
008500         03  TR-FLPT-DATA        PIC X(12).                       00860000
008600         03  FILLER              PIC X(1).                        00870000
008700         03  TR-FLPT-SIZE        PIC 9(2).                        00880000
008800         03  FILLER              PIC X(60).                       00890000
008900                                                                  00900000
009000     02  FILLER                  REDEFINES TR-DATA.               00910000
009100         03  TR-IHEX-DATA        PIC X(12).                       00920000
009200         03  FILLER              PIC X(1).                        00930000
009300         03  TR-IHEX-SIZE        PIC 9(2).                        00940000
009400         03  FILLER              PIC X(60).                       00950000
009500                                                                  00960000
009600     02  FILLER                  REDEFINES TR-DATA.               00970000
009700         03  TR-LJST-DATA        PIC X(12).                       00980000
009800         03  FILLER              PIC X(1).                        00990000
009900         03  TR-LJST-SIZE        PIC 9(2).                        01000000
010000         03  FILLER              PIC X(60).                       01010000
010100                                                                  01020000
010200     02  FILLER                  REDEFINES TR-DATA.               01030000
010300         03  TR-MASK-DATA        PIC X(16).                       01040000
010400         03  FILLER              PIC X(1).                        01050000
010500         03  TR-MASK-SIZE        PIC 9(2).                        01060000
010600         03  FILLER              PIC X(1).                        01070000
010700         03  TR-MASK-MASK        PIC X(16).                       01080000
010800         03  FILLER              PIC X(39).                       01090000
010900                                                                  01100000
011000     02  FILLER                  REDEFINES TR-DATA.               01110000
011100         03  TR-NIB-DATA         PIC X(12).                       01120000
011200         03  FILLER              PIC X(1).                        01130000
011300         03  TR-NIB-SIZE         PIC 9(2).                        01140000
011400         03  FILLER              PIC X(60).                       01150000
011500                                                                  01160000
011600     02  FILLER                  REDEFINES TR-DATA.               01170000
011700         03  TR-OHEX-DATA        PIC X(12).                       01180000
011800         03  FILLER              PIC X(1).                        01190000
011900         03  TR-OHEX-SIZE        PIC 9(2).                        01200000
012000         03  FILLER              PIC X(60).                       01210000
012100                                                                  01220000
012200     02  FILLER                  REDEFINES TR-DATA.               01230000
012300         03  TR-MONY-DATA        PIC S9(11)V9(2).                 01240000
012400         03  FILLER              PIC X(62).                       01250000
012500                                                                  01260000
012600* ************************************************************* * 01270000
012700* FOLLOWING ARE INTERMEDIATE FIELDS USING TO PREPARE AND        * 01280000
012800* INTERPRET DATA PASSED TO/FROM THE ROUTINES                    * 01290000
012900* ************************************************************* * 01300000
013000 01  INTER-PROGRAM-DATA.                                          01310000
013100     02  FIELD-SIZE              PIC S9(4)   COMP.                01320000
013200                                                                  01330000
013300     02  FLPT-OUTPUT             PIC S9(11)V9(7).                 01340000
013400                                                                  01350000
013500     02  OUTPUT-FIELD            PIC X(160).                      01360000
013600     02  FILLER                  REDEFINES OUTPUT-FIELD.          01370000
013700         03  OUTPUT-NUMEDIT      PIC 9(11)V9(7)-.                 01380000
013800         03  FILLER              PIC X(141).                      01390000
013900     02  FILLER                  REDEFINES OUTPUT-FIELD.          01400000
014000         03  OUTPUT-CHUNK1       PIC X(55).                       01410000
014100         03  OUTPUT-CHUNK2       PIC X(55).                       01420000
014200         03  OUTPUT-CHUNK3       PIC X(50).                       01430000
014300                                                                  01440000
014400* ************************************************************* * 01450000
014500* FOLLOWING ARE THE REPORT HEADING AND DETAIL DESCRIPTIONS.     * 01460000
014600* ************************************************************* * 01470000
014700                                                                  01480000
014800 01  HEADING-1.                                                   01490000
014900     02  FILLER  PIC X(1) VALUE ' '.                              01500000
015000     02  FILLER  PIC X(6) VALUE 'DATE: '.                         01510000
015100     02  H1-DATE PIC X(8).                                        01520000
015200     02  FILLER  PIC X(32) VALUE SPACES.                          01530000
015300     02  FILLER  PIC X(36) VALUE                                  01540000
015400         'INPUT/OUTPUT FIELD EDIT SUBROUTINES '.                  01550000
015500     02  FILLER  PIC X(35) VALUE SPACES.                          01560000
015600     02  FILLER  PIC X(15) VALUE 'PROGRAM: FMTIVP'.               01570000
015700                                                                  01580000
015800 01  HEADING-2.                                                   01590000
015900     02  FILLER  PIC X(1) VALUE ' '.                              01600000
016000     02  FILLER  PIC X(6) VALUE 'TIME: '.                         01610000
016100     02  H2-TIME PIC X(5).                                        01620000
016200     02  FILLER  PIC X(36) VALUE SPACES.                          01630000
016300     02  FILLER  PIC X(33) VALUE                                  01640000
016400         'INSTALLATION VERIFICATION PROGRAM'.                     01650000
016500     02  FILLER  PIC X(40) VALUE SPACES.                          01660000
016600     02  FILLER  PIC X(9) VALUE 'PAGE:   '.                       01670000
016700     02  H2-PAGE PIC ZZ9.                                         01680000
016800                                                                  01690000
016900 01  HEADING-3.                                                   01700000
017000     02  FILLER  PIC X(1) VALUE ' '.                              01710000
017100     02  FILLER  PIC X(22) VALUE                                  01720000
017200         'TEST DATA INPUT RECORD'.                                01730000
017300     02  FILLER  PIC X(39) VALUE SPACES.                          01740000
017400     02  FILLER  PIC X(7) VALUE 'ROUTINE'.                        01750000
017500     02  FILLER  PIC X(2) VALUE SPACES.                           01760000
017600     02  FILLER  PIC X(3) VALUE 'R/C'.                            01770000
017700     02  FILLER  PIC X(59) VALUE SPACES.                          01780000
017800                                                                  01790000
017900 01  DETAIL-LINE.                                                 01800000
018000     02  FILLER  PIC X(1) VALUE ' '.                              01810000
018100     02  DL-TEST-RECORD          PIC X(50).                       01820000
018200     02  FILLER                  PIC X(11) VALUE SPACES.          01830000
018300     02  DL-ROUTINE-NAME         PIC X(7).                        01840000
018400     02  FILLER                  PIC X(2) VALUE SPACES.           01850000
018500     02  DL-SLASH-1              PIC X.                           01860000
018600     02  DL-RETURN-CODE          PIC 9.                           01870000
018610     02  DL-RETURN-CODE-X        REDEFINES DL-RETURN-CODE         01880000
018620                                 PIC X.                           01890000
018700     02  DL-SLASH-2              PIC X.                           01900000
018800     02  FILLER                  PIC X(2) VALUE SPACES.           01910000
018900     02  DL-COMMON-FORMAT        PIC X(57).                       01920000
019000                                                                  01930000
019100 01  DETAIL-FLPT.                                                 01940000
019200     02  DCONV-DATEG             PIC X(10).                       01950000
019300     02  FILLER                  PIC X(2) VALUE SPACES.           01960000
019400     02  DCONV-DATEJ             PIC X(8).                        01970000
019500     02  FILLER                  PIC X(2) VALUE SPACES.           01980000
019600     02  DCONV-ANUM              PIC 9,999,999.                   01990000
019700/                                                                 02000000
019800 PROCEDURE DIVISION.                                              02010000
019900                                                                  02020000
020000 0000-MAIN SECTION.                                               02030000
020100                                                                  02040000
020200 0050-SETUP.                                                      02050000
020300     MOVE TIME-OF-DAY TO UNFORMATTED-GDATE.                       02060000
020400     MOVE '  :  ' TO FORMATTED-GDATE.                             02070000
020500     MOVE UNFORMATTED-GMONTH TO FORMATTED-GMONTH.                 02080000
020600     MOVE UNFORMATTED-GDAY   TO FORMATTED-GDAY.                   02090000
020700     MOVE FORMATTED-GDATE TO H2-TIME.                             02100000
020800     MOVE CURRENT-DATE TO H1-DATE.                                02110000
020900                                                                  02120000
021000 0100-CONTROL.                                                    02130000
021100     OPEN INPUT DATA-FILE,                                        02140000
021200          OUTPUT PRINT-FILE.                                      02150000
021300                                                                  02160000
021400     PERFORM 0200-READ-DATA-FILE                                  02170000
021500        THRU 0299-READ-DATA-FILE-EXIT.                            02180000
021600                                                                  02190000
021700     PERFORM 0300-PROCESS-DATA                                    02200000
021800        THRU 0399-PROCESS-DATA-EXIT                               02210000
021900       UNTIL END-OF-DATA.                                         02220000
022000                                                                  02230000
022100     CLOSE DATA-FILE, PRINT-FILE.                                 02240000
022200                                                                  02250000
022300     STOP RUN.                                                    02260000
022400* - - - - - - - - - - - - - - - - PROGRAM EXIT POINT              02270000
022500                                                                  02280000
022600 0200-READ-DATA-FILE.                                             02290000
022700     READ DATA-FILE                                               02300000
022800         AT END MOVE 'Y' TO END-OF-DATA-SWITCH.                   02310000
022900                                                                  02320000
023000 0299-READ-DATA-FILE-EXIT.                                        02330000
023100     EXIT.                                                        02340000
023200* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              02350000
023300                                                                  02360000
023400 0300-PROCESS-DATA.                                               02370000
023500     MOVE SPACES TO DETAIL-LINE.                                  02380000
023600     MOVE DATA-RECORD TO TEST-RECORD, DL-TEST-RECORD.             02390000
023700                                                                  02400000
023800     IF TR-IDENTIFICATION EQUAL 'FILL'                            02410000
023900         PERFORM 0400-CALL-FILL THRU 0400-CALL-FILL-EXIT          02420000
024000         GO TO 0300-CONTINUE.                                     02430000
024100                                                                  02440000
024200     IF TR-IDENTIFICATION EQUAL 'FLPT'                            02450000
024300         PERFORM 0410-CALL-FLPT THRU 0410-CALL-FLPT-EXIT          02460000
024400         GO TO 0300-CONTINUE.                                     02470000
024500                                                                  02480000
024600     IF TR-IDENTIFICATION EQUAL 'IHEX'                            02490000
024700         PERFORM 0415-CALL-IHEX THRU 0415-CALL-IHEX-EXIT          02500000
024800         GO TO 0300-CONTINUE.                                     02510000
024900                                                                  02520000
025000     IF TR-IDENTIFICATION EQUAL 'LJST'                            02530000
025100         PERFORM 0420-CALL-LJST THRU 0420-CALL-LJST-EXIT          02540000
025200         GO TO 0300-CONTINUE.                                     02550000
025300                                                                  02560000
025400     IF TR-IDENTIFICATION EQUAL 'MASK'                            02570000
025500         PERFORM 0425-CALL-MASK THRU 0425-CALL-MASK-EXIT          02580000
025600         GO TO 0300-CONTINUE.                                     02590000
025700                                                                  02600000
025800     IF TR-IDENTIFICATION EQUAL 'NIB '                            02610000
025900         PERFORM 0430-CALL-NIB THRU 0430-CALL-NIB-EXIT            02620000
026000         GO TO 0300-CONTINUE.                                     02630000
026100                                                                  02640000
026200     IF TR-IDENTIFICATION EQUAL 'OHEX'                            02650000
026300         PERFORM 0435-CALL-OHEX THRU 0435-CALL-OHEX-EXIT          02660000
026400         GO TO 0300-CONTINUE.                                     02670000
026500                                                                  02680000
026600     IF TR-IDENTIFICATION EQUAL 'MONY'                            02690000
026700         PERFORM 0440-CALL-MONY THRU 0440-CALL-MONY-EXIT          02700000
026800         GO TO 0300-CONTINUE.                                     02710000
026900                                                                  02720000
027000     MOVE '-------' TO DL-ROUTINE-NAME                            02730000
027100     MOVE '*' TO DL-SLASH-1, DL-SLASH-2, DL-RETURN-CODE-X         02740000
027200     MOVE 'INVALID ROUTINE SPECIFIED' TO DL-COMMON-FORMAT.        02750000
027300                                                                  02760000
027400  0300-CONTINUE.                                                  02770000
027500     MOVE +0 TO RETURN-CODE.                                      02780000
027600                                                                  02790000
027700     IF DETAIL-LINE NOT EQUAL SPACES                              02800000
027800         PERFORM 0500-PRINT-ROUTINE THRU 0500-EXIT.               02810000
027900                                                                  02820000
028000     PERFORM 0200-READ-DATA-FILE                                  02830000
028100        THRU 0299-READ-DATA-FILE-EXIT.                            02840000
028200                                                                  02850000
028300 0399-PROCESS-DATA-EXIT.                                          02860000
028400     EXIT.                                                        02870000
028500* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              02880000
028600                                                                  02890000
028700 0400-CALL-FILL.                                                  02900000
028800     MOVE 'I-FILL ' TO DL-ROUTINE-NAME.                           02910000
028900     MOVE TR-FILL-SIZE TO FIELD-SIZE.                             02920000
029000                                                                  02930000
029100     CALL 'IFMTFILL' USING TR-FILL-DATA, FIELD-SIZE.              02940000
029200                                                                  02950000
029300     MOVE RETURN-CODE TO DL-RETURN-CODE.                          02960000
029400                                                                  02970000
029500     IF RETURN-CODE EQUAL 0                                       02980000
029600         GO TO 0400-CALL-FILL-EXIT.                               02990000
029700                                                                  03000000
029800     MOVE '*' TO DL-SLASH-1, DL-SLASH-2.                          03010000
029900     IF RETURN-CODE EQUAL 8                                       03020000
030000         MOVE 'FIELD WAS NOT FILLED'                              03030000
030100           TO DL-COMMON-FORMAT                                    03040000
030200         GO TO 0400-CALL-FILL-EXIT.                               03050000
030300                                                                  03060000
030400 0400-CALL-FILL-EXIT.                                             03070000
030500     EXIT.                                                        03080000
030600* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              03090000
030700                                                                  03100000
030800 0410-CALL-FLPT.                                                  03110000
030900     MOVE 'I-FLPT ' TO DL-ROUTINE-NAME.                           03120000
031000     MOVE TR-FLPT-SIZE TO FIELD-SIZE.                             03130000
031100                                                                  03140000
031200     CALL 'IFMTFLPT' USING TR-FLPT-DATA, FIELD-SIZE,              03150000
031300                           FLPT-OUTPUT.                           03160000
031400                                                                  03170000
031500     MOVE RETURN-CODE TO DL-RETURN-CODE.                          03180000
031600                                                                  03190000
031700     IF RETURN-CODE EQUAL 0                                       03200000
031800         MOVE SPACES TO OUTPUT-FIELD                              03210000
031900         MOVE FLPT-OUTPUT TO OUTPUT-NUMEDIT                       03220000
032000         MOVE OUTPUT-FIELD TO DL-COMMON-FORMAT                    03230000
032100         GO TO 0410-CALL-FLPT-EXIT.                               03240000
032200                                                                  03250000
032300     MOVE '*' TO DL-SLASH-1, DL-SLASH-2.                          03260000
032400     IF RETURN-CODE EQUAL 8                                       03270000
032500         MOVE 'INVALID FLOATING POINT FORMAT'                     03280000
032600           TO DL-COMMON-FORMAT                                    03290000
032700         GO TO 0410-CALL-FLPT-EXIT.                               03300000
032800                                                                  03310000
032900 0410-CALL-FLPT-EXIT.                                             03320000
033000     EXIT.                                                        03330000
033100* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              03340000
033200                                                                  03350000
033300 0415-CALL-IHEX.                                                  03360000
033400     MOVE 'I-HEX  ' TO DL-ROUTINE-NAME.                           03370000
033500     MOVE TR-IHEX-SIZE TO FIELD-SIZE.                             03380000
033600     MOVE SPACES TO OUTPUT-FIELD.                                 03390000
033700                                                                  03400000
033800     CALL 'IFMTHEX' USING TR-IHEX-DATA, FIELD-SIZE,               03410000
033900                          OUTPUT-FIELD.                           03420000
034000                                                                  03430000
034100     MOVE RETURN-CODE TO DL-RETURN-CODE.                          03440000
034200                                                                  03450000
034300     IF RETURN-CODE EQUAL 0                                       03460000
034400         MOVE OUTPUT-FIELD TO DL-COMMON-FORMAT                    03470000
034500         GO TO 0415-CALL-IHEX-EXIT.                               03480000
034600                                                                  03490000
034700     MOVE '*' TO DL-SLASH-1, DL-SLASH-2.                          03500000
034800     IF RETURN-CODE EQUAL 8                                       03510000
034900         MOVE 'INVALID HEX DIGIT IN INPUT'                        03520000
035000           TO DL-COMMON-FORMAT                                    03530000
035100         GO TO 0415-CALL-IHEX-EXIT.                               03540000
035200                                                                  03550000
035300 0415-CALL-IHEX-EXIT.                                             03560000
035400     EXIT.                                                        03570000
035500* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              03580000
035600                                                                  03590000
035700 0420-CALL-LJST.                                                  03600000
035800     MOVE 'I-LJST ' TO DL-ROUTINE-NAME.                           03610000
035900     MOVE TR-LJST-SIZE TO FIELD-SIZE.                             03620000
036000     MOVE SPACES TO OUTPUT-FIELD.                                 03630000
036100                                                                  03640000
036200     CALL 'IFMTLJST' USING TR-LJST-DATA, FIELD-SIZE.              03650000
036400                                                                  03670000
036500     MOVE RETURN-CODE TO DL-RETURN-CODE.                          03680000
036600                                                                  03690000
036700     IF RETURN-CODE EQUAL 0                                       03700000
036800         MOVE TR-LJST-DATA TO DL-COMMON-FORMAT                    03710000
036900         GO TO 0420-CALL-LJST-EXIT.                               03720000
037000                                                                  03730000
037100 0420-CALL-LJST-EXIT.                                             03740000
037200     EXIT.                                                        03750000
037300* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              03760000
037400                                                                  03770000
037500 0425-CALL-MASK.                                                  03780000
037600     MOVE 'I-MASK ' TO DL-ROUTINE-NAME.                           03790000
037700     MOVE TR-MASK-SIZE TO FIELD-SIZE.                             03800000
037800     MOVE SPACES TO OUTPUT-FIELD.                                 03810000
037900                                                                  03820000
038000     CALL 'IFMTMASK' USING TR-MASK-DATA, FIELD-SIZE,              03830000
038100                           TR-MASK-MASK, OUTPUT-FIELD.            03840000
038200                                                                  03850000
038300     MOVE RETURN-CODE TO DL-RETURN-CODE.                          03860000
038400                                                                  03870000
038500     IF RETURN-CODE EQUAL 0                                       03880000
038600         MOVE OUTPUT-FIELD TO DL-COMMON-FORMAT                    03890000
038700         GO TO 0425-CALL-MASK-EXIT.                               03900000
038800                                                                  03910000
038900     MOVE '*' TO DL-SLASH-1, DL-SLASH-2.                          03920000
039000     IF RETURN-CODE EQUAL 8                                       03930000
039100         MOVE 'INPUT DOES NOT CONFORM TO MASK'                    03940000
039200           TO DL-COMMON-FORMAT                                    03950000
039300         GO TO 0425-CALL-MASK-EXIT.                               03960000
039400                                                                  03970000
039500 0425-CALL-MASK-EXIT.                                             03980000
039600     EXIT.                                                        03990000
039700* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              04000000
039800                                                                  04010000
039900 0430-CALL-NIB.                                                   04020000
040000     MOVE 'I-NIB  ' TO DL-ROUTINE-NAME.                           04030000
040100     MOVE TR-NIB-SIZE TO FIELD-SIZE.                              04040000
040200                                                                  04050000
040300     CALL 'IFMTNIB' USING TR-NIB-DATA, FIELD-SIZE.                04060000
040400                                                                  04070000
040500     MOVE RETURN-CODE TO DL-RETURN-CODE.                          04080000
040600                                                                  04090000
040700     IF RETURN-CODE EQUAL 0                                       04100000
040800         GO TO 0430-CALL-NIB-EXIT.                                04110000
040900                                                                  04120000
041000     MOVE '*' TO DL-SLASH-1, DL-SLASH-2.                          04130000
041100     IF RETURN-CODE EQUAL 8                                       04140000
041200         MOVE 'FIELD CONTAINS EMBEDDED BLANKS'                    04150000
041300           TO DL-COMMON-FORMAT                                    04160000
041400         GO TO 0430-CALL-NIB-EXIT.                                04170000
041500                                                                  04180000
041600 0430-CALL-NIB-EXIT.                                              04190000
041700     EXIT.                                                        04200000
041800* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              04210000
041900                                                                  04220000
042000 0435-CALL-OHEX.                                                  04230000
042100     MOVE 'O-HEX  ' TO DL-ROUTINE-NAME.                           04240000
042200     MOVE TR-OHEX-SIZE TO FIELD-SIZE.                             04250000
042300     MOVE SPACES TO OUTPUT-FIELD.                                 04260000
042400                                                                  04270000
042500     CALL 'OFMTHEX' USING TR-OHEX-DATA, FIELD-SIZE,               04280000
042600                          OUTPUT-FIELD.                           04290000
042700                                                                  04300000
042800     MOVE RETURN-CODE TO DL-RETURN-CODE.                          04310000
042900                                                                  04320000
043000     IF RETURN-CODE EQUAL 0                                       04330000
043100         MOVE OUTPUT-FIELD TO DL-COMMON-FORMAT                    04340000
043200         GO TO 0435-CALL-OHEX-EXIT.                               04350000
043300                                                                  04360000
043400 0435-CALL-OHEX-EXIT.                                             04370000
043500     EXIT.                                                        04380000
043600* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              04390000
043700                                                                  04400000
043800 0440-CALL-MONY.                                                  04410000
043900     MOVE 'O-MONY ' TO DL-ROUTINE-NAME.                           04420000
044000     MOVE SPACES TO OUTPUT-FIELD.                                 04430000
044100                                                                  04440000
044200     CALL 'OFMTMONY' USING TR-MONY-DATA, OUTPUT-FIELD.            04450000
044300                                                                  04460000
044400     MOVE RETURN-CODE TO DL-RETURN-CODE.                          04470000
044500                                                                  04480000
044600     IF RETURN-CODE EQUAL 0                                       04490000
044700         GO TO 0440-CALL-MONY-OK.                                 04500000
044800                                                                  04510000
044900     MOVE '*' TO DL-SLASH-1, DL-SLASH-2.                          04520000
045000     IF RETURN-CODE EQUAL 4                                       04530000
045100         MOVE 'NEGATIVE INPUT VALUE'                              04540000
045200           TO DL-COMMON-FORMAT                                    04550000
045300         GO TO 0440-CALL-MONY-EXIT.                               04560000
045400                                                                  04570000
045500     IF RETURN-CODE EQUAL 8                                       04580000
045600         MOVE 'NON-NUMERIC CHARACTER IN INPUT'                    04590000
045700           TO DL-COMMON-FORMAT                                    04600000
045800         GO TO 0440-CALL-MONY-EXIT.                               04610000
045900                                                                  04620000
046000 0440-CALL-MONY-OK.                                               04630000
046100     MOVE OUTPUT-CHUNK1 TO DL-COMMON-FORMAT.                      04640000
046200     PERFORM 0500-PRINT-ROUTINE THRU 0500-EXIT.                   04650000
046300     MOVE SPACES TO DETAIL-LINE.                                  04660000
046400                                                                  04670000
046500     IF OUTPUT-CHUNK2 EQUAL SPACES                                04680000
046600         GO TO 0440-CALL-MONY-EXIT.                               04690000
046700                                                                  04700000
046800     MOVE OUTPUT-CHUNK2 TO DL-COMMON-FORMAT.                      04710000
046900     PERFORM 0500-PRINT-ROUTINE THRU 0500-EXIT.                   04720000
047000     MOVE SPACES TO DETAIL-LINE.                                  04730000
047100                                                                  04740000
047200     IF OUTPUT-CHUNK3 EQUAL SPACES                                04750000
047300         GO TO 0440-CALL-MONY-EXIT.                               04760000
047400                                                                  04770000
047500     MOVE OUTPUT-CHUNK3 TO DL-COMMON-FORMAT.                      04780000
047600     PERFORM 0500-PRINT-ROUTINE THRU 0500-EXIT.                   04790000
047700     MOVE SPACES TO DETAIL-LINE.                                  04800000
047800                                                                  04810000
047900 0440-CALL-MONY-EXIT.                                             04820000
048000     EXIT.                                                        04830000
048100* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              04840000
048200                                                                  04850000
048300 0500-PRINT-ROUTINE.                                              04860000
048400     IF LINE-COUNT LESS THAN PAGE-SIZE                            04870000
048500         GO TO 0500-DETAIL.                                       04880000
048600                                                                  04890000
048700     IF LINE-COUNT LESS THAN 99                                   04900000
048800         GO TO 0500-PAGEHEAD.                                     04910000
048900                                                                  04920000
049000     MOVE SPACES TO PRINT-RECORD.                                 04930000
049100     WRITE PRINT-RECORD AFTER ADVANCING TO-FIRST-LINE.            04940000
049200                                                                  04950000
049300  0500-PAGEHEAD.                                                  04960000
049400     ADD 1 TO PAGE-COUNT                                          04970000
049500     MOVE PAGE-COUNT TO H2-PAGE                                   04980000
049600     WRITE PRINT-RECORD FROM HEADING-1 BEFORE ADVANCING 1         04990000
049700     WRITE PRINT-RECORD FROM HEADING-2 BEFORE ADVANCING 2         05000000
049800     WRITE PRINT-RECORD FROM HEADING-3 BEFORE ADVANCING 1         05010000
049900     MOVE 4 TO LINE-COUNT.                                        05020000
050000                                                                  05030000
050100 0500-DETAIL.                                                     05040000
050200     WRITE PRINT-RECORD FROM DETAIL-LINE BEFORE ADVANCING 1.      05050000
050300     ADD 1 TO LINE-COUNT.                                         05060000
050400                                                                  05070000
050500 0500-EXIT.                                                       05080000
050600     EXIT.                                                        05090000
050700* - - - - - - - - - - - - - - - - PERFORM EXIT POINT              05100000
050800                                                                  05110000
./       ADD   NAME=FMTIVPD
FILL 123456       06                              <
FILL 123          05                         <ERR><
FILL   345        05                         <ERR><
FLPT 123          12                              <
FLPT 123.45       12                              <
FLPT -123         12                              <
FLPT 123-         12                              <
FLPT    -123.45   12                              <
FLPT   123.45-    12                              <
FLPT      123.45- 12                              <
FLPT    --123     12                         <ERR><
FLPT 1.12345678   12                         <ERR><
FLPT 123456789012 12                         <ERR><
FLPT    123.A5    12                         <ERR><
IHEX C1C2C3F8F9   10                              <
IHEX C            01                         <ERR><
LJST    905       10                              <
LJST  307 AB      10                              <
MASK (864) 555-1212   14 (999) 999-9999           <
MASK (A64) 555-1212   14 (999) 999-9999      <ERR><
MASK 29307-1792       10 99999-9999               <
MASK SS#155 23 4871   14 SS#999-99-9999      <ERR><
MASK SS#155-23-4871   14 SS#999-99-9999           <
MASK Y408             04 X999                     <
MASK 408Y             04 X999                <ERR><
NIB    1234       08                              <
NIB  123          04                              <
NIB           123 12                              <
NIB   1  456      08                         <ERR><
OHEX ABCDEF123    09                              <
OHEX $}@.         04                              <
MONY 0000000000000                          <VOID><
MONY 000000000005L                           <NEG><
MONY 0000000A00500                           <ERR><
MONY 0000000513429                                <
MONY 0000001000000                                <
MONY 7777777777777                       <MAX OUT><
MONY 9999999999999                        <MAX IN><
MONY 0000000001201                                <
./       ADD   NAME=IFMTFILL
         TITLE 'IFMTFILL - ENSURE ALL CHARACTERS FILLED ON INPUT'       00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    IIII   FFFFFFF M     M TTTTTTTT FFFFFFF  IIII   LL      LL       * 00040000
*     II    FF      MM   MM    TT    FF        II    LL      LL       * 00050000
*     II    FF      MMM MMM    TT    FF        II    LL      LL       * 00060000
*     II    FFFFF   MMMMMMM    TT    FFFFF     II    LL      LL       * 00070000
*     II    FF      MM M MM    TT    FF        II    LL      LL       * 00080000
*     II    FF      MM   MM    TT    FF        II    LL      LL       * 00090000
*     II    FF      MM   MM    TT    FF        II    LL      LL       * 00100000
*    IIII   FF      MM   MM    TT    FF       IIII   LLLLLLL LLLLLLL  * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE SCANS AN INPUT FIELD (DISPLAY FORMAT) TO VERIFY     * 00140000
* THAT ALL CHARACTERS ARE FILLED (NO LEADING, TRAILING, OR EMBEDDED   * 00150000
* BLANKS).                                                            * 00160000
*                                                                     * 00170000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00180000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00190000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00200000
*                                                                     * 00210000
* TWO FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:                 * 00220000
*                                                                     * 00230000
*   1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT DATA, AND       * 00240000
*   2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF     * 00250000
*      THE FIRST FIELD PASSED.                                        * 00260000
*                                                                     * 00270000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00280000
*                                                                     * 00290000
*              CALL IFMTFILL,(INFIELD,INLENGTH)                       * 00300000
*                 . . .                                               * 00310000
*     INFIELD  DS   CL12'ABCDEF-12345'                                * 00320000
*     INLENGTH DS   H'12'                                             * 00330000
*                                                                     * 00340000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00350000
*                                                                     * 00360000
*     01  INPUT-FIELD           PIC X(12) VALUE 'ABCDEF-12345'.       * 00370000
*     01  INPUT-FIELD-LENGTH    PIC S9(4) COMP VALUE 12.              * 00380000
*                                                                     * 00390000
*     CALL 'IFMTFILL' USING INPUT FIELD, INPUT-FIELD-LENGTH.          * 00400000
*                                                                     * 00410000
* POSSIBLE RETURN CODE VALUES:                                        * 00420000
*     0 - NO BLANK CHARACTERS FOUND WITHIN FIELD                      * 00430000
*     8 - BLANK CHARACTER(S) FOUND WITHIN FIELD                       * 00440000
* ******************************************************************* * 00450000
* ******************************************************************* * 00460000
         EJECT                                                          00470000
         PRINT NOGEN                                                    00480000
IFMTFILL CSECT                                                          00490000
         EYEC  'VERIFY INPUT FIELD IS FILLED'                           00500000
         SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00510000
*                                                                       00520000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00530000
         USING *,BASE                  ASSUME BASE REGISTER             00540000
*                                                                       00550000
         LM    INREG,LGTHREG,0(R1)     LOAD ADDRESSES OF PARAMETERS     00560000
*                                                                       00570000
         SR    R15,R15                 ASSUME RETURN CODE OF ZERO       00580000
*                                                                       00590000
         LH    LGTHREG,0(,LGTHREG)     GET LENGTH OF INPUT FIELD        00600000
         LTR   LGTHREG,LGTHREG         IS INPUT FIELD LENGTH ZERO?      00610000
         BZ    RETURN                     IF YES, RETURN TO CALLER      00620000
*                                                                       00630000
         BCTR  LGTHREG,0               DECREASE BY 1 FOR EXECUTE        00640000
         EX    LGTHREG,FINDBL          SCAN FOR BLANK                   00650000
         BZ    RETURN                  IF NO BLANKS FOUND               00660000
*                                                                       00670000
*    IF ANY BLANKS WERE FOUND, RETURN CODE IS SET TO "8"                00680000
*                                                                       00690000
ERROR    LA    R15,8                    RETURN CODE OF 8                00700000
*                                                                       00710000
*    RETURN TO CALLING PROGRAM WITH RETURN CODE IN REGISTER 15          00720000
*                                                                       00730000
RETURN   RETURN (14,12),RC=(15)                                         00740000
*                                                                       00750000
*    TRT PERFORMED VIA EXECUTE WITH FIELD LENGTH MODIFIER               00760000
*                                                                       00770000
FINDBL   TRT   0(0,INREG),TABLEBL       SCAN FOR BLANK CHARACTER        00780000
*                                                                       00790000
* ******************************************************************* * 00800000
* *************************** CONSTANTS ***************************** * 00810000
* ******************************************************************* * 00820000
TABLEBL  DC    64X'00'                                                  00830000
         DC    X'01'                                                    00840000
         DC    191X'00'                                                 00850000
         LTORG                                                          00860000
         EJECT                                                          00870000
* ******************************************************************* * 00880000
* ***************************** EQUATES ***************************** * 00890000
* ******************************************************************* * 00900000
R0       EQU   0                       REGISTER 0                       00910000
R1       EQU   1                       REGISTER 1                       00920000
R2       EQU   2                       REGISTER 2                       00930000
R3       EQU   3                       REGISTER 3                       00940000
R4       EQU   4                       REGISTER 4                       00950000
INREG    EQU   5                       INPUT FIELD                      00960000
LGTHREG  EQU   6                       INPUT FIELD LENGTH               00970000
R7       EQU   7                       REGISTER 7                       00980000
R8       EQU   8                       REGISTER 8                       00990000
R9       EQU   9                       REGISTER 9                       01000000
R10      EQU   10                      REGISTER 10                      01010000
R11      EQU   11                      REGISTER 11                      01020000
BASE     EQU   12                      BASE REGISTER                    01030000
R13      EQU   13                      REGISTER 13                      01040000
R14      EQU   14                      REGISTER 14                      01050000
R15      EQU   15                      REGISTER 15                      01060000
         END                                                            01070000
./       ADD   NAME=IFMTFLPT
         TITLE 'IFMTFLPT - PARSE SIGNED FLOATING POINT INPUT FIELD'     00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    IIII   FFFFFFF M     M TTTTTTTT FFFFFFF LL      PPPPPP TTTTTTTT  * 00040000
*     II    FF      MM   MM    TT    FF      LL      PP   PP   TT     * 00050000
*     II    FF      MMM MMM    TT    FF      LL      PP   PP   TT     * 00060000
*     II    FFFFF   MMMMMMM    TT    FFFFF   LL      PP   PP   TT     * 00070000
*     II    FF      MM M MM    TT    FF      LL      PPPPPP    TT     * 00080000
*     II    FF      MM   MM    TT    FF      LL      PP        TT     * 00090000
*     II    FF      MM   MM    TT    FF      LL      PP        TT     * 00100000
*    IIII   FF      MM   MM    TT    FF      LLLLLLL PP        TT     * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE SCANS AN INPUT FIELD (DISPLAY FORMAT) ASSUMED TO    * 00140000
* CONTAIN A FLOATING POINT NUMERIC VALUE. THE EXPECTED FORMAT IS:     * 00150000
*                                                                     * 00160000
*    1. ANY NUMBER OF LEADING OR TRAILING SPACES (WILL BE IGNORED)    * 00170000
*    2. A LEADING OR TRAILING SIGN (+ OR - CHARACTER; OPTIONAL)       * 00180000
*    3. ONE TO ELEVEN DIGITS REPRESENTING THE INTEGRAL (WHOLE) VALUE  * 00190000
*    4. A DECIMAL POINT (OPTIONAL)                                    * 00200000
*    5. ONE TO SEVEN DIGITS REPRESENTING THE DECIMAL VALUE (OPTIONAL) * 00210000
*                                                                     * 00220000
*  NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S * 00230000
*  EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION  * 00240000
*  IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.    * 00250000
*                                                                     * 00260000
* THREE FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:               * 00270000
*                                                                     * 00280000
*    1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT CHARACTERS,    * 00290000
*    2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF    * 00300000
*       THE FIELD IN THE FIRST PARAMETER, AND                         * 00310000
*    4. AN 18 BYTE FIELD (ZONED-DECIMAL FORMAT) TO RECEIVE THE        * 00320000
*       EXTRACTED NUMERIC DATA.                                       * 00330000
*                                                                     * 00340000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00350000
*                                                                     * 00360000
*              CALL IFMTFLPT,(INFIELD,INLEN,OUTFIELD)                 * 00370000
*                 . . .                                               * 00380000
*     INFIELD  DS   CL10'  -107.10 '                                  * 00390000
*     INLEN    DS   H'10'                                             * 00400000
*     OUTFIELD DS   ZL18                                              * 00410000
*                                                                     * 00420000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00430000
*                                                                     * 00440000
*     01  IFMTFLPT-PARMS.                                             * 00450000
*         02  INPUT-FIELD         PIC X(10) VALUE '  -107.10 '.       * 00460000
*         02  INPUT-FIELD-LENGTH  PIC S9(4) COMP VALUE 10.            * 00470000
*         02  OUTPUT-FIELD        PIC X9(11)V9(7).                    * 00480000
*                                                                     * 00490000
*     CALL 'IFMTFLPT' USING INPUT-FIELD, INPUT-FIELD-LENGTH,          * 00500000
*                           OUTPUT-FIELD.                             * 00510000
*                                                                     * 00520000
* THE POSSIBLE VALUE FOR THE RETURN CODE ARE:                         * 00530000
*                                                                     * 00540000
*     0 - FIELD SUCCESSFULLY CONVERTED                                * 00550000
*     8 - INPUT FIELD DOES NOT CONFORM TO ACCEPTABLE FORMAT RULES     * 00560000
* ******************************************************************* * 00570000
* ******************************************************************* * 00580000
         EJECT                                                          00590000
         PRINT NOGEN                                                    00600000
IFMTFLPT CSECT                                                          00610000
         EYEC  'EXTRACT NUMERIC VALUE FROM FLOATING POINT INPUT FIELD'  00640000
         SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00650000
*                                                                       00660000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00670000
         USING *,BASE                  ASSUME BASE REGISTER             00680000
*                                                                       00690000
         LM    INREG,OUTREG,0(R1)      LOAD ADDRESSES OF PARAMETERS     00700000
*                                                                       00710000
         LH    FLDLEN,0(,FLDLEN)       LOAD LENGTH OF INPUT FIELD       00720000
*                                                                       00730000
         SR    R15,R15                 ASSUME GOOD RETURN               00740000
*                                                                       00750000
         ICM   STATUS,B'0001',=C'0'    INITIAL STATUS IS "FIELD BEGIN"  00760000
         ICM   STATUS,B'0010',=C'+'    DEFAULT SIGN IS POSITIVE         00770000
         SR    INTBEG,INTBEG           ZERO TO INTEGER BEGIN,           00780000
         SR    INTLEN,INTLEN                    INTEGER LENGTH          00790000
         SR    DECBEG,DECBEG                    DECIMAL BEGIN,          00800000
         SR    DECLEN,DECLEN                    DECIMAL LENGTH          00810000
*                                                                       00820000
         MVI   0(OUTREG),C'0'          SET OUTPUT FIELD TO              00830000
         MVC   1(17,OUTREG),0(OUTREG)     ALL ZEROS                     00840000
*                                                                       00850000
         LTR   FLDLEN,FLDLEN           IS INPUT LENGTH ZERO?            00860000
         BZ    RETURN                     YES, RETURN TO CALLER         00870000
*                                                                       00880000
LOOP     CLI   0(INREG),C' '           IS CHARACTER BLANK?              00890000
         BE    INBLANK                    YES, PROCESS                  00900000
         CLI   0(INREG),C'-'           IS CHARACTER MINUS SIGN?         00910000
         BE    INSIGN                     YES, PROCESS                  00920000
         CLI   0(INREG),C'+'           IS CHARACTER PLUS SIGN?          00930000
         BE    INSIGN                     YES, PROCESS                  00940000
         CLI   0(INREG),C'.'           IS CHARACTER DECIMAL POINT?      00950000
         BE    INPOINT                    YES, PROCESS                  00960000
*                                                                       00970000
DIGIT    CLI   0(INREG),X'F0'          IS CHARACTER LESS THAN 0?        00980000
         BL    ERROR                      YES, RETURN ERROR CODE        00990000
         CLI   0(INREG),X'F9'          IS CHARACTER GREATER THAN 9?     01000000
         BH    ERROR                      YES, RETURN ERROR CODE        01010000
DIGIT0   CLM   STATUS,B'0001',=C'0'    AT "FIELD BEGIN"?                01020000
         BNE   DIGIT2                     NO, TEST FURTHER              01030000
DIGIT1   ICM   STATUS,B'0001',=C'2'    SET STATUS "INTEGER STARTED"     01040000
         LR    INTBEG,INREG            STORE INTEGER BEGINNING ADDR     01050000
         LA    INTLEN,1                INITIALIZE INTEGER LENGTH        01060000
         B     NEXT                    CONTINUE SCANNING                01070000
DIGIT2   CLM   STATUS,B'0001',=C'1'    AT "FIELD STARTED"?              01080000
         BE    DIGIT1                     PROCESS SAME AS "FIELD BEGIN" 01090000
         CLM   STATUS,B'0001',=C'2'    IS "INTEGER STARTED"?            01100000
         BNE   DIGIT3                     NO, TEST FURTHER              01110000
         LA    INTLEN,1(,INTLEN)       INCREASE INTEGER COUNT           01120000
         B     NEXT                    CONTINUE SCANNING                01130000
DIGIT3   CLM   STATUS,B'0001',=C'3'    IS "DECIMAL STARTED"?            01140000
         BNE   ERROR                      NO, RETURN ERROR CODE         01150000
         LA    DECLEN,1(,DECLEN)       INCREASE DECIMAL COUNT           01160000
*                                                                       01170000
NEXT     LA    INREG,1(,INREG)         ADDRESS NEXT INPUT CHARACTER     01180000
         BCT   FLDLEN,LOOP              AND CONTINUE UNTIL INPUT END    01190000
*                                                                       01200000
         CH    INTLEN,=H'11'           IF INTEGER LENGTH IS GREATER     01210000
         BH    ERROR                      THAN 11 RETURN ERROR CODE     01220000
         CH    DECLEN,=H'7'            IF DECIMAL LENGTH IS GREATER     01230000
         BH    ERROR                      THAN 7 RETURN ERROR CODE      01240000
INTEGER  LTR   INTLEN,INTLEN           IS INTEGER LENGTH ZERO?          01250000
         BZ    DECIMAL                    YES, GO CHECK DECIMAL         01260000
         LA    R3,11(,OUTREG)          RIGHT ADJUST INTEGER IN          01270000
         SR    R3,INTLEN                  OUTPUT FIELD                  01280000
         BCTR  INTLEN,0                DECREASE BY 1 FOR EXECUTE        01290000
         EX    INTLEN,MOVEINT          MOVE INTEGER TO OUTPUT FIELD     01300000
DECIMAL  LTR   DECLEN,DECLEN           IS DECIMAL LENGTH ZERO?          01310000
         BZ    SETSIGN                    YES, GO SET SIGN              01320000
         LA    R3,11(,OUTREG)          LEFT ADJUST DECIMAL IN OUTPUT    01330000
         BCTR  DECLEN,0                DECREASE BY 1 FOR EXECUTE        01340000
         EX    DECLEN,MOVEDEC          MOVE DECIMAL TO OUTPUT FIELD     01350000
*                                                                       01360000
SETSIGN  CLM   STATUS,B'0010',=C'-'    WAS INPUT SIGN NEGATIVE?         01370000
         BE    SEGSIGN0                   YES, GO SET NEGATIVE          01380000
         NI    17(OUTREG),X'CF'        SET POSITIVE                     01390000
         B     RETURN                   AND RETURN TO CALLER            01400000
SEGSIGN0 NI    17(OUTREG),X'DF'        SET NEGATIVE                     01410000
         B     RETURN                   AND RETURN TO CALLER            01420000
*                                                                       01430000
INBLANK  CLM   STATUS,B'0001',=C'0'    AT "FIELD BEGIN"?                01440000
         BE    NEXT                       YES, CONTINUE SCANNING        01450000
         CLM   STATUS,B'0001',=C'2'    IS "INTEGER STARTED"?            01460000
         BE    INBLANKX                   YES, MARK END OF FIELD        01470000
         CLM   STATUS,B'0001',=C'3'    IS "DECIMAL STARTED"?            01480000
         BE    INBLANKX                   YES, MARK END OF FIELD        01490000
         CLM   STATUS,B'0001',=C'4'    AT "FIELD END"?                  01500000
         BE    NEXT                       YES, CONTINUE SCANNING        01510000
         B     ERROR                   EMBEDDED BLANK, RETURN ERROR     01520000
INBLANKX ICM   STATUS,B'0001',=C'4'    SET STATUS "FIELD END"           01530000
         B     NEXT                    CONTINUE SCANNING                01540000
*                                                                       01550000
INSIGN   CLM   STATUS,B'0001',=C'0'    AT "FIELD BEGIN"?                01560000
         BE    INSIGN1                    YES, STORE SIGN/UPDATE STATUS 01570000
         CLM   STATUS,B'0001',=C'2'    IS "INTEGER STARTED"?            01580000
         BE    INSIGN2                    YES, STORE SIGN/UPDATE STATUS 01590000
         CLM   STATUS,B'0001',=C'3'    IS "DECIMAL STARTED"?            01600000
         BE    INSIGN2                    YES, STORE SIGN/UPDATE STATUS 01610000
         B     ERROR                   BAD SIGN LOCATION                01620000
INSIGN1  ICM   STATUS,B'0010',0(INREG) STORE SIGN                       01630000
         ICM   STATUS,B'0001',=C'1'    SET STATUS "FIELD STARTED"       01640000
         B     NEXT                    CONTINUE SCANNING                01650000
INSIGN2  ICM   STATUS,B'0010',0(INREG) STORE SIGN                       01660000
         ICM   STATUS,B'0001',=C'4'    SET STATUS "FIELD END"           01670000
         B     NEXT                    CONTINUE SCANNING                01680000
*                                                                       01690000
INPOINT  CLM   STATUS,B'0001',=C'0'    AT "FIELD BEGIN"?                01700000
         BE    INPOINTX                   YES, STORE ADDR/UPDATE STATUS 01710000
         CLM   STATUS,B'0001',=C'1'    AT "FIELD STARTED"?              01720000
         BE    INPOINTX                   YES, STORE ADDR/UPDATE STATUS 01730000
         CLM   STATUS,B'0001',=C'2'    IS "INTEGER STARTED"?            01740000
         BNE   ERROR                      BAD PERIOD LOCATION           01750000
INPOINTX ICM   STATUS,B'0001',=C'3'    SET STATUS "DECIMAL STARTED"     01760000
         LA    DECBEG,1(,INREG)        STORE DECIMAL BEGIN ADDRESS      01770000
         B     NEXT                    CONTINUE SCANNING                01780000
*                                                                       01790000
ERROR    LA    R15,8                   RETURN CODE OF 8                 01800000
RETURN   RETURN (14,12),RC=(15)        RETURN TO CALLER                 01810000
*                                                                       01820000
MOVEINT  MVC   0(0,R3),0(INTBEG)       MOVE INTEGER TO OUTPUT FIELD     01830000
MOVEDEC  MVC   0(0,R3),0(DECBEG)       MOVE DECIMAL TO OUTPUT FIELD     01840000
*                                                                       01850000
* ******************************************************************* * 01860000
* *************************** CONSTANTS ***************************** * 01870000
* ******************************************************************* * 01880000
         LTORG                                                          01890000
* ******************************************************************* * 01900000
* **************************** EQUATES ****************************** * 01910000
* ******************************************************************* * 01920000
R0       EQU   0                       REGISTER 0                       01930000
R1       EQU   1                       REGISTER 1                       01940000
R2       EQU   2                       REGISTER 2                       01950000
R3       EQU   3                       REGISTER 3                       01960000
STATUS   EQU   4                       STATUS OF EXTRACTION             01970000
INREG    EQU   5                       INPUT FIELD ADDRESS              01980000
FLDLEN   EQU   6                       INPUT FIELD LENGTH               01990000
OUTREG   EQU   7                       OUTPUT FIELD ADDRESS             02000000
INTBEG   EQU   8                       INTEGER BEGIN ADDRES             02010000
INTLEN   EQU   9                       INTEGER LENGTH                   02020000
DECBEG   EQU   10                      DECIMAL BEGIN ADDRESS            02030000
DECLEN   EQU   11                      DECIMAL LENGTH                   02040000
BASE     EQU   12                      BASE REGISTER                    02050000
R13      EQU   13                      REGISTER 13                      02060000
R14      EQU   14                      REGISTER 14                      02070000
R15      EQU   15                      REGISTER 15                      02080000
         EJECT                                                          02090000
         END                                                            02100000
./       ADD   NAME=IFMTHEX
         TITLE 'IFMTHEX - CONVERT INPUT HEX DATA FIELD TO HEX DIGITS'   00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    IIII   FFFFFFF M     M TTTTTTTT HH   HH EEEEEE  XX   XX          * 00040000
*     II    FF      MM   MM    TT    HH   HH EE      XX   XX          * 00050000
*     II    FF      MMM MMM    TT    HH   HH EE       XX XX           * 00060000
*     II    FFFFF   MMMMMMM    TT    HHHHHHH EEEE      XXX            * 00070000
*     II    FF      MM M MM    TT    HH   HH EE        XXX            * 00080000
*     II    FF      MM   MM    TT    HH   HH EE       XX XX           * 00090000
*     II    FF      MM   MM    TT    HH   HH EE      XX   XX          * 00100000
*    IIII   FF      MM   MM    TT    HH   HH EEEEEEE XX   XX          * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE READS AN INPUT FIELD (DISPLAY FORMAT) WHERE EACH    * 00140000
* 2 BYTES REPRESENT THE CHARACTER REPRESENTATION OF A PAIR OF HEX     * 00150000
* DIGITS AND CONVERTS THEM INTO THE CORRESPONDING OUTPUT CHARACTER.   * 00160000
*                                                                     * 00170000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00180000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00190000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00200000
*                                                                     * 00210000
* THREE FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:               * 00220000
*                                                                     * 00230000
*   1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT CHARACTERS,     * 00240000
*   2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF     * 00250000
*      THE INPUT FIELD (THIS NUMBER MUST BE EVENLY DIVISIBLE BY 2),   * 00260000
*   3. A FIELD TO CONTAIN THE GENERATED HEX CHARACTERS.               * 00270000
*                                                                     * 00280000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00290000
*                                                                     * 00300000
*             CALL IFMTHEX,(INFIELD,INLENGTH,OUTFIELD)                * 00310000
*                . . .                                                * 00320000
*    INFIELD  DS   CL12'F1F2F3C1C2C3'                                 * 00330000
*    INLENGTH DS   H'12'                                              * 00340000
*    OUTFIELD DS   CL6'123ABC'                                        * 00350000
*                                                                     * 00360000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00370000
*                                                                     * 00380000
*     01  INPUT-FIELD           PIC X(12) VALUE 'F1F2F3C1C2C3'.       * 00390000
*     01  INPUT-FIELD-LENGTH    PIC S9(4) COMP VALUE 12.              * 00400000
*     01  OUTPUT-FIELD          PIC X(6).                             * 00410000
*                                                                     * 00420000
*     CALL 'IFMTHEX' USING INPUT-FIELD, INPUT-FIELD-LENGTH,           * 00430000
*                          OUTPUT-FIELD.                              * 00440000
*                                                                     * 00450000
* NOTE: INPUT-FIELD-LENGTH MUST BE EVENLY DIVISIBLE BY 2. THE LENGTH  * 00460000
*       OF THE OUTPUT-FIELD SHOULD BE HALF THAT OF THE INPUT-FIELD.   * 00470000
*                                                                     * 00480000
* POSSIBLE RETURN CODE VALUES:                                        * 00490000
*     0 - FIELD SUCCESSFULLY CONVERTED                                * 00500000
*     8 - INPUT FIELD DOES NOT CONTAIN VALID "HEX" DIGITS             * 00510000
* ******************************************************************* * 00520000
* ******************************************************************* * 00530000
         EJECT                                                          00540000
         PRINT NOGEN                                                    00550000
IFMTHEX  CSECT                                                          00560000
         EYEC  'CONVERT INPUT HEX FIELD INTO HEX DIGITS'                00590000
BEGIN    SAVE  (14,12)                 SAVE SALLER'S REGISTERS          00600000
*                                                                       00610000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00620000
         USING *,BASE                  ASSUME BASE REGISTER             00630000
*                                                                       00640000
         LM    INREG,OUTREG,0(R1)      LOAD ADDRESSES OF PARAMETERS     00650000
*                                                                       00660000
         SR    R15,R15                 ASSUME RETURN CODE OF ZERO       00670000
*                                                                       00680000
         LH    LGTHREG,0(,LGTHREG)     LOAD FIELD LENGTH                00690000
         LTR   LGTHREG,LGTHREG         IS OUTPUT FIELD LENGTH ZERO?     00700000
         BZ    RETURN                    YES, JUST RETURN TO CALLER     00710000
*                                                                       00720000
         LR    R2,LGTHREG              COPY LENGTH FOR TEST             00730000
         N     R2,=F'1'                IS LENGTH EVEN (1 BIT OFF)?      00740000
         BNZ   ERROR                      NO, RETURN ERROR              00750000
*                                                                       00760000
         SRA   LGTHREG,1                DIVIDE LENGTH BY 2              00770000
*                                                                       00780000
*    MAIN LOOP EXECUTED 1 PASS FOR EACH 2 BYTES INPUT                   00790000
*                                                                       00800000
BYTELOOP SR    R2,R2                   CLEAR WORK REGISTER              00810000
         LA    R4,2                    DO NIBBLE LOOP TWICE             00820000
*                                                                       00830000
*    SUBORDINATE LOOP EXECUTED 2 PASSES FOR EACH INPUT BYTE             00840000
*                                                                       00850000
NIBLLOOP SR    R3,R3                   CLEAR WORK REGISTER              00860000
         IC    R3,0(,INREG)            GET CHARACTER FROM INPUT         00870000
         C     R3,=F'193'              COMPARE TO CHARACTER "A"         00880000
         BL    ERROR                      IF LESS, BAD CHARACTER        00890000
         C     R3,=F'198'              COMPARE TO CHARACTER "F"         00900000
         BH    DIGIT                      IF GREATER, CHECK FOR DIGIT   00910000
         SH    R3,=H'183'              CONVERT TO BINARY                00920000
         B     SAVENIBL                SAVE NIBBLE                      00930000
DIGIT    C     R3,=F'240'              COMPARE TO DIGIT "0"             00940000
         BL    ERROR                      IF LESS, BAD CHARACTER        00950000
         C     R3,=F'249'              COMPARE TO DIGIT "9"             00960000
         BH    ERROR                      IF GREATER, BAD CHARACTER     00970000
         SH    R3,=F'240'              CONVERT TO BINARY                00980000
SAVENIBL SLL   R3,28                   SHIFT NIBBLE LEFT IN REGISTER    00990000
         SLDL  R2,4                    SHIFT NIBBLE INTO R2             01000000
         LA    INREG,1(,INREG)         BUMP INPUT ADDRESS               01010000
         BCT   R4,NIBLLOOP             CONVERT NEXT NIBBLE              01020000
*                                                                       01030000
         STC   R2,0(,OUTREG)           STORE CONVERTED BYTE             01040000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              01050000
         BCT   LGTHREG,BYTELOOP        CONVERT NEXT BYTE                01060000
*                                                                       01070000
*    AT COMPLETION OF OUTER LOOP, JUMP TO COMMON RETURN POINT           01080000
*                                                                       01090000
         B     RETURN                  RETURN TO CALLER                 01100000
*                                                                       01110000
*    ERROR OCCURRED, SET RETURN CODE                                    01120000
*                                                                       01130000
ERROR    LA    R15,8                   RETURN CODE OF 8                 01140000
*                                                                       01150000
*    RETURN TO CALLER WITH RETURN CODE IN REGISTER 15                   01160000
*                                                                       01170000
RETURN   RETURN (14,12),RC=(15)                                         01180000
         SPACE                                                          01190000
* ******************************************************************* * 01200000
* *************************** CONSTANTS ***************************** * 01210000
* ******************************************************************* * 01220000
         LTORG                                                          01230000
         EJECT                                                          01240000
* ******************************************************************* * 01250000
* ***************************** EQUATES ***************************** * 01260000
* ******************************************************************* * 01270000
R0       EQU   0                       REGISTER 0                       01280000
R1       EQU   1                       REGISTER 1                       01290000
R2       EQU   2                       REGISTER 2                       01300000
R3       EQU   3                       REGISTER 3                       01310000
R4       EQU   4                       REGISTER 4                       01320000
INREG    EQU   5                       INPUT FIELD                      01330000
LGTHREG  EQU   6                       INPUT FIELD LENGTH               01340000
OUTREG   EQU   7                       OUTPUT FIELD                     01350000
R8       EQU   8                       REGISTER 8                       01360000
R9       EQU   9                       REGISTER 9                       01370000
R10      EQU   10                      REGISTER 10                      01380000
R11      EQU   11                      REGISTER 11                      01390000
BASE     EQU   12                      BASE REGISTER                    01400000
R13      EQU   13                      REGISTER 13                      01410000
R14      EQU   14                      REGISTER 14                      01420000
R15      EQU   15                      REGISTER 15                      01430000
         END                                                            01440000
./       ADD   NAME=IFMTLJST
         TITLE 'IFMTLJST - LEFT JUSTIFY DATA IN FIELD'                  00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    IIII   FFFFFFF M     M TTTTTTTT LL           JJ  SSSSS TTTTTTTT  * 00040000
*     II    FF      MM   MM    TT    LL           JJ SS   SS   TT     * 00050000
*     II    FF      MMM MMM    TT    LL           JJ SS        TT     * 00060000
*     II    FFFFF   MMMMMMM    TT    LL           JJ  SSSSS    TT     * 00070000
*     II    FF      MM M MM    TT    LL           JJ      SS   TT     * 00080000
*     II    FF      MM   MM    TT    LL      JJ   JJ SS   SS   TT     * 00090000
*     II    FF      MM   MM    TT    LL      JJ   JJ SS   SS   TT     * 00100000
*    IIII   FF      MM   MM    TT    LLLLLLL  JJJJJ   SSSSS    TT     * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE LEFT JUSTIFIES THE DATA IN AN INPUT FIELD (DISPLAY  * 00140000
* FORMAT) BY LOCATING THE FIRST NON-BLANK CHARACTER AND THEN MOVING   * 00150000
* THE CONTENTS OF THE FIELD FROM THAT POSITION TO THE END OF THE      * 00160000
* FIELD INTO THE LEFT-MOST BYT OF THE FIELD. THE REMAINDER OF THE     * 00170000
* FIELD IS THEN FILLED WITH BLANKS.                                   * 00180000
*                                                                     * 00190000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00200000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00210000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00220000
*                                                                     * 00230000
* TWO FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:                 * 00240000
*                                                                     * 00250000
*   1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT DATA, AND       * 00260000
*   2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF     * 00270000
*      THE FIRST FIELD PASSED.                                        * 00280000
*                                                                     * 00290000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00300000
*                                                                     * 00310000
*              CALL IFMTLJST,(INFIELD,INLENGTH)                       * 00320000
*                 . . .                                               * 00330000
*     INFIELD  DS   CL12'   128.25   '                                * 00340000
*     INLENGTH DS   H'12'                                             * 00350000
*                                                                     * 00360000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00370000
*                                                                     * 00380000
*     01  INPUT-FIELD           PIC X(12) VALUE '   128.25   '.       * 00390000
*     01  INPUT-FIELD-LENGTH    PIC S9(4) COMP VALUE 12.              * 00400000
*                                                                     * 00410000
*     CALL 'IFMTLJST' USING INPUT FIELD, INPUT-FIELD-LENGTH.          * 00420000
*                                                                     * 00430000
* POSSIBLE RETURN CODE VALUES:                                        * 00440000
*     0 - FIELD SUCCESSFULLY LEFT-JUSTIFIED                           * 00450000
* ******************************************************************* * 00460000
* ******************************************************************* * 00470000
         EJECT                                                          00480000
         PRINT NOGEN                                                    00490000
IFMTLJST CSECT                                                          00500000
         EYEC  'LEFT JUSTIFY DATA IN INPUT FIELD'                       00530000
BEGIN    SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00540000
*                                                                       00550000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00560000
         USING *,BASE                  ASSUME BASE REGISTER             00570000
*                                                                       00580000
         LM    INREG,LGTHREG,0(R1)     LOAD ADDRESSES OF PARAMETERS     00590000
*                                                                       00600000
         LH    LGTHREG,0(,LGTHREG)     GET LENGTH OF INPUT FIELD        00610000
         LTR   LGTHREG,LGTHREG         IS FIELD LENGTH ZERO?            00620000
         BZ    RETURN                    IF YES, RETURN TO CALLER       00630000
*                                                                       00640000
         CLI   0(INREG),C' '           IS FIRST CHARACTER BLANK         00650000
         BNE   RETURN                    IF NOT, RETURN TO CALLER       00660000
*                                                                       00670000
         LR    R7,LGTHREG              LENGTH OF FIELD                  00680000
         BCTR  R7,0                    DECREASE BY 1 FOR EXECUTE        00690000
         EX    R7,FINDNB               FIND FIRST NON-BLANK             00700000
         BC    0,RETURN                  IF ALL BLANKS, RETURN          00710000
*                                                                       00720000
*    COMPUTE LENGTH OF DATA TO MOVE LEFT                                00730000
*                                                                       00740000
         AR    R7,INREG                ADD BEGINNING OF FIELD ADDRESS   00750000
         SR    R7,R1                   SUBTRACT 1ST NON-BLANK ADDRESS   00760000
         EX    R7,VARMOVE              MOVE NON-BLANK CONTENTS LEFT     00770000
         LA    R7,1(,R7)               RESTORE ACTUAL LENGTH OF DATA    00780000
*                                                                       00790000
*    COMPUTE ADDRESS TO BEGIN BLANK FILLING REMAINDER OF FIELD          00800000
*                                                                       00810000
         LR    R8,INREG                BEGINNING OF FIELD ADDRESS       00820000
         AR    R8,R7                   ADD SIGNIFICANT CHARACTERS       00830000
         MVI   0(R8),C' '              MOVE FIRST BLANK                 00840000
*                                                                       00850000
*    COMPUTE NUMBER OF BLANKS TO BE INSERTED                            00860000
*                                                                       00870000
         LR    R9,LGTHREG              LENGTH OF INPUT FIELD            00880000
         SR    R9,R7                   SUBTRACT SIGNIFICANT CHARACTERS  00890000
         BCTR  R9,0                    DECREASE BY THE FIRST BLANK      00900000
         LTR   R9,R9                   CHECK FOR ZERO LENGTH            00910000
         BZ    RETURN                     IF ZERO, JUST RETURN          00920000
         BCTR  R9,0                    DECREASE BY 1 FOR EXECUTE        00930000
         EX    R9,BLANKS               MOVE BLANKS TO FILL FIELD        00940000
*                                                                       00950000
*    RETURN TO CALLER WITH RETURN CODE (0) IN REGISTER 15               00960000
*                                                                       00970000
RETURN   RETURN (14,12),RC=0                                            00980000
*                                                                       00990000
*    TRT PERFORMED VIA EXECUTE FROM ABOVE TO FIND 1ST NON-BLANK         01000000
*                                                                       01010000
FINDNB   TRT   0(0,INREG),TRTABLE       SCAN FOR NON-BLANK CHARACTERS   01020000
*                                                                       01030000
*    MVC PERFORMED VIA EXECUTE FROM ABOVE TO MOVE DATA LEFT IN FIELD    01040000
*                                                                       01050000
VARMOVE  MVC   0(0,INREG),0(R1)         MOVE NON-BLANK PORTION LEFT     01060000
*                                                                       01070000
*    MVC PERFORMED VIA EXECUTE FROM ABOVE TO BLANK REMAINDER OF FIELD   01080000
*                                                                       01090000
BLANKS   MVC   1(0,R8),0(R8)            BLANK REMAINDER OF FIELD        01100000
*                                                                       01110000
* ******************************************************************* * 01120000
* *************************** CONSTANTS ***************************** * 01130000
* ******************************************************************* * 01140000
TRTABLE  DC    64X'01'                 TABLE TO FIND NON-BLANK          01150000
         DC    X'00'                                                    01160000
         DC    191X'01'                                                 01170000
         LTORG                                                          01180000
         EJECT                                                          01190000
* ******************************************************************* * 01200000
* ***************************** EQUATES ***************************** * 01210000
* ******************************************************************* * 01220000
R0       EQU   0                       REGISTER 0                       01230000
R1       EQU   1                       REGISTER 1                       01240000
R2       EQU   2                       REGISTER 2                       01250000
R3       EQU   3                       REGISTER 3                       01260000
R4       EQU   4                       REGISTER 4                       01270000
INREG    EQU   5                       INPUT FIELD                      01280000
LGTHREG  EQU   6                       INPUT FIELD LENGTH               01290000
R7       EQU   7                       REGISTER 7                       01300000
R8       EQU   8                       REGISTER 8                       01310000
R9       EQU   9                       REGISTER 9                       01320000
R10      EQU   10                      REGISTER 10                      01330000
R11      EQU   11                      REGISTER 11                      01340000
BASE     EQU   12                      BASE REGISTER                    01350000
R13      EQU   13                      REGISTER 13                      01360000
R14      EQU   14                      REGISTER 14                      01370000
R15      EQU   15                      REGISTER 15                      01380000
         END                                                            01390000
./       ADD   NAME=IFMTMASK
         TITLE 'IFMTMASK - EDIT INPUT FIELD BY USING FORMAT MASK'       00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    IIII   FFFFFFF M     M TTTTTTTT M     M    A     SSSSS  KK   KK  * 00040000
*     II    FF      MM   MM    TT    MM   MM   AAA   SS   SS KK  KK   * 00050000
*     II    FF      MMM MMM    TT    MMM MMM  AA AA  SS      KK KK    * 00060000
*     II    FFFFF   MMMMMMM    TT    MMMMMMM AA   AA  SSSSS  KKKK     * 00070000
*     II    FF      MM M MM    TT    MM M MM AA   AA      SS KKKK     * 00080000
*     II    FF      MM   MM    TT    MM   MM AAAAAAA SS   SS KK KK    * 00090000
*     II    FF      MM   MM    TT    MM   MM AA   AA SS   SS KK  KK   * 00100000
*    IIII   FF      MM   MM    TT    MM   MM AA   AA  SSSSS  KK   KK  * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE SCANS AN INPUT FIELD (DISPLAY FORMAT) AND MOVES THE * 00140000
* CHARACTERS TO AN OUTPUT FIELD BASED UPON THE CORRESPONDING BYTE IN  * 00150000
* A FORMAT MASK AS FOLLOWS:                                           * 00160000
*                                                                     * 00170000
*    1. IF A FORMAT BYTE IS '9' THEN THE CORRESPONDING INPUT BYTE     * 00180000
*       MUST BE NUMERIC (0 THROUGH 9). THE INPUT BYTE IS MOVED TO THE * 00190000
*       OUTPUT FIELD.                                                 * 00200000
*    2. IF A FORMAT BYTE IS 'X' THEN NO EDIT IS PERFORMED. THE INPUT  * 00210000
*       BYTE IS MOVED TO THE OUTPUT FIELD.                            * 00220000
*    3. IF A FORMAT BYTE IS ANYTHING OTHER THAN '9' OR 'X' THEN THE   * 00230000
*       CORRESPONDING INPUT BYTE MUST BE THE SAME CHARACTER. THE      * 00240000
*       INPUT BYTE IS NOT MOVED TO THE OUTPUT FIELD.                  * 00250000
*                                                                     * 00260000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00270000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00280000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00290000
*                                                                     * 00300000
* FOUR FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:                * 00310000
*                                                                     * 00320000
*   1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT CHARACTERS,     * 00330000
*   2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF     * 00340000
*      THE FORMAT MASK FIELD (BY DEFINITION, THIS IS ALSO THE         * 00350000
*      LENGTH OF THE INPUT FIELD),                                    * 00360000
*   3. A FIELD CONTAINING THE FORMAT MASK, AND                        * 00370000
*   4. A FIELD TO CONTAIN THE CHARACTERS EXTRACTED FROM THE INPUT     * 00380000
*      FIELD.                                                         * 00390000
*                                                                     * 00400000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00410000
*                                                                     * 00420000
*              CALL IFMTMASK,(INFIELD,FMTLEN,FMTMASK,OUTFIELD)        * 00430000
*                 . . .                                               * 00440000
*     INFIELD  DS   CL14'(915) 695-7000'                              * 00450000
*     FMTLEN   DS   H'14'                                             * 00460000
*     FMTMASK  DS   CL14'(999) 999-9999'                              * 00470000
*     OUTFIELD DS   ZL10                                              * 00480000
*                                                                     * 00490000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00500000
*                                                                     * 00510000
*     01  INPUT-FIELD         PIC X(14) VALUE '(915) 695-7000'.       * 00520000
*     01  FORMAT-FIELD-LENGTH PIC S9(4) COMP VALUE 14.                * 00530000
*     01  FORMAT-MASK         PIC X(14) VALUE '(999) 999-9999'.       * 00540000
*     01  OUTPUT-FIELD        PIC 9(10).                              * 00550000
*                                                                     * 00560000
*     CALL 'IFMTMASK' USING INPUT-FIELD, INPUT-FIELD-LENGTH,          * 00570000
*                           FORMAT-MASK, OUTPUT-FIELD.                * 00580000
*                                                                     * 00590000
* NOTE: BY DEFINITION, THE INPUT FIELD AND THE FORMAT MASK FIELD WILL * 00600000
*       HAVE THE SAME LENGTH.                                         * 00610000
*                                                                     * 00620000
* POSSIBLE RETURN CODE VALUES:                                        * 00630000
*     0 - FIELD SUCCESSFULLY CONVERTED                                * 00640000
*     8 - INPUT FIELD DOES NOT CONFORM TO ACCEPTABLE FORMAT RULES     * 00650000
* ******************************************************************* * 00660000
* ******************************************************************* * 00670000
         EJECT                                                          00680000
         PRINT NOGEN                                                    00690000
IFMTMASK CSECT                                                          00700000
         EYEC  'EDIT INPUT FIELD USING FORMAT MASK'                     00730000
BEGIN    SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00740000
*                                                                       00750000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00760000
         USING *,BASE                  ASSUME BASE REGISTER             00770000
*                                                                       00780000
         LM    INREG,OUTREG,0(R1)      LOAD ADDRESSES OF PARAMETERS     00790000
*                                                                       00800000
         SR    R15,R15                 ASSUME RETURN CODE OF ZERO       00810000
*                                                                       00820000
         LH    LGTHREG,0(,LGTHREG)     LOAD FIELD LENGTH                00830000
         LTR   LGTHREG,LGTHREG         IS INPUT FIELD LENGTH ZERO?      00840000
         BZ    RETURN                     YES, JUST RETURN TO CALLER    00850000
*                                                                       00860000
*    MAIN FIELD PROCESSING LOOP                                         00870000
*                                                                       00880000
LOOP     CLI   0(MASKREG),C'9'         IS NUMERIC BYTE EXPECTED?        00890000
         BE    NUMMOVE                    YES, GO PROCESS               00900000
         CLI   0(MASKREG),C'X'         IS ANY CHARACTER ACCEPTABLE?     00910000
         BE    ALPMOVE                    YES, GO PROCESS               00920000
*                                                                       00930000
*    INPUT BYTE MUST MATCH MASK BYTE                                    00940000
*                                                                       00950000
         CLC   0(1,MASKREG),0(INREG)   DO THEY MATCH?                   00960000
         BNE   ERROR                      NO, RETURN ERROR              00970000
         B     ENDLOOP                 JUMP TO COMMON EXIT POINT        00980000
*                                                                       00990000
*    INPUT BYTE MUST BE NUMERIC DIGIT (X'F0' - X'F9')                   01000000
*                                                                       01010000
NUMMOVE  CLI   0(INREG),C'0'           IS BYTE LESS THAN X'F0'          01020000
         BL    ERROR                      YES, RETURN ERROR             01030000
         CLI   0(INREG),C'9'           IS BYTE GREATER THAN X'F9'       01040000
         BH    ERROR                      YES, RETURN ERROR             01050000
*                                                                       01060000
*    ANY BYTE IS ACCEPTABLE, MOVE TO OUTPUT FIELD                       01070000
*                                                                       01080000
ALPMOVE  MVC   0(1,OUTREG),0(INREG)    MOVE INPUT BYTE TO OUTPUT FIELD  01090000
         LA    OUTREG,1(OUTREG)        POINT TO NEXT OUTPUT CHARACTER   01100000
*                                                                       01110000
*    TERMINATION POINT FOR MAIN LOOP                                    01120000
*                                                                       01130000
ENDLOOP  LA    MASKREG,1(,MASKREG)     POINT TO NEXT FORMAT CHARACTER   01140000
         LA    INREG,1(,INREG)         POINT TO NEXT INPUT CHARACTER    01150000
         BCT   LGTHREG,LOOP            LOOP FOR EACH CHARACTER IN MASK  01160000
*                                                                       01170000
*    AT END OF LOOP, BRANCH AROUND ERROR TO COMMON RETURN POINT         01180000
*                                                                       01190000
         B     RETURN                                                   01200000
*                                                                       01210000
*    AN ERROR WAS FOUND IN THE INPUT, RETURN CODE IS SET TO "8"         01220000
*                                                                       01230000
ERROR    LA    R15,8                   RETURN CODE OF 8                 01240000
*                                                                       01250000
*    RETURN TO CALLER WITH RETURN CODE IN REGISTER 15                   01260000
*                                                                       01270000
RETURN   RETURN (14,12),RC=(15)                                         01280000
*                                                                       01290000
* ******************************************************************* * 01300000
* *************************** CONSTANTS ***************************** * 01310000
* ******************************************************************* * 01320000
         LTORG                                                          01330000
         EJECT                                                          01340000
* ******************************************************************* * 01350000
* **************************** EQUATES ****************************** * 01360000
* ******************************************************************* * 01370000
R0       EQU   0                       REGISTER 0                       01380000
R1       EQU   1                       REGISTER 1                       01390000
R2       EQU   2                       REGISTER 2                       01400000
R3       EQU   3                       REGISTER 3                       01410000
R4       EQU   4                       REGISTER 4                       01420000
INREG    EQU   5                       INPUT FIELD                      01430000
LGTHREG  EQU   6                       INPUT LENGTH                     01440000
MASKREG  EQU   7                       FORMAT MASK                      01450000
OUTREG   EQU   8                       OUTPUT FIELD                     01460000
R9       EQU   9                       REGISTER 9                       01470000
R10      EQU   10                      REGISTER 10                      01480000
R11      EQU   11                      REGISTER 11                      01490000
BASE     EQU   12                      BASE REGISTER                    01500000
R13      EQU   13                      REGISTER 13                      01510000
R14      EQU   14                      REGISTER 14                      01520000
R15      EQU   15                      REGISTER 15                      01530000
* ******************************************************************* * 01540000
         END                                                            01550000
./       ADD   NAME=IFMTNIB
         TITLE 'IFMTNIB - VERIFY NO EMBEDED BLANKS IN INPUT FIELD'      00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    IIII   FFFFFFF M     M TTTTTTTT NN   NN  IIII   BBBBBB           * 00040000
*     II    FF      MM   MM    TT    NNN  NN   II    BB   BB          * 00050000
*     II    FF      MMM MMM    TT    NNN  NN   II    BB   BB          * 00060000
*     II    FFFFF   MMMMMMM    TT    NNNN NN   II    BBBBBB           * 00070000
*     II    FF      MM M MM    TT    NN NNNN   II    BB   BB          * 00080000
*     II    FF      MM   MM    TT    NN  NNN   II    BB   BB          * 00090000
*     II    FF      MM   MM    TT    NN  NNN   II    BB   BB          * 00100000
*    IIII   FF      MM   MM    TT    NN   NN  IIII   BBBBBB           * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE SCANS AN INPUT FIELD (DISPLAY FORMAT) TO VERIFY     * 00140000
* THAT THERE ARE NO EMBEDDED BLANKS. THERE CAN BE LEADING BLANKS AND  * 00150000
* TRAILING BLANKS, BUT NO BLANKS MAY OCCUR AFTER THE FIRST NON-BLANK  * 00160000
* CHARACTER IS ENCOUNTERED.                                           * 00170000
*                                                                     * 00180000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00190000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00200000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00210000
*                                                                     * 00220000
* TWO FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:                 * 00230000
*                                                                     * 00240000
*   1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT DATA, AND       * 00250000
*   2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF     * 00260000
*      THE FIRST FIELD PASSED.                                        * 00270000
*                                                                     * 00280000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00290000
*                                                                     * 00300000
*              CALL IFMTNIB,(INFIELD,INLENGTH)                        * 00310000
*                 . . .                                               * 00320000
*     INFIELD  DS   CL12'   128.25   '                                * 00330000
*     INLENGTH DS   H'12'                                             * 00340000
*                                                                     * 00350000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00360000
*                                                                     * 00370000
*     01  INPUT-FIELD           PIC X(12) VALUE '   128.25   '.       * 00380000
*     01  INPUT-FIELD-LENGTH    PIC S9(4) COMP VALUE 12.              * 00390000
*                                                                     * 00400000
*     CALL 'IFMTNIB' USING INPUT FIELD, INPUT-FIELD-LENGTH.           * 00410000
*                                                                     * 00420000
* POSSIBLE RETURN CODE VALUES:                                        * 00430000
*     0 - DATA IN FIELD CONTAINS NO IMBEDDED BLANKS                   * 00440000
*     8 - FIELD CONTAINS IMBEDDED BLANKS                              * 00450000
* ******************************************************************* * 00460000
* ******************************************************************* * 00470000
         EJECT                                                          00480000
         PRINT NOGEN                                                    00490000
IFMTNIB  CSECT                                                          00500000
         EYEC  'VERIFY NO EMBEDDED BLANKS IN INPUT FIELD'               00530000
BEGIN    SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00540000
*                                                                       00550000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00560000
         USING *,BASE                  ASSUME BASE REGISTER             00570000
*                                                                       00580000
         LM    INREG,LGTHREG,0(R1)     LOAD ADDRESSES OF PARAMETERS     00590000
*                                                                       00600000
         SR    R15,R15                 ASSUME RETURN CODE OF ZERO       00610000
*                                                                       00620000
         LH    LGTHREG,0(,LGTHREG)     GET LENGTH OF INPUT FIELD        00630000
         LTR   LGTHREG,LGTHREG         IS LENGTH OF FIELD ZERO?         00640000
         BZ    RETURN                     IF YES, RETURN TO CALLER      00650000
*                                                                       00660000
*    FIND FIRST NON-BLANK CHARACTER IN FIELD                            00670000
*                                                                       00680000
         LR    R7,INREG                BEGINNING OF FIELD               00690000
         LR    R8,LGTHREG              LENGTH OF FIELD                  00700000
         BCTR  R8,0                    DECREASE BY 1 FOR EXECUTE        00710000
         EX    R8,FINDNB               FIND FIRST NON-BLANK             00720000
         BZ    RETURN                     IF ALL BLANKS, RETURN         00730000
*                                                                       00740000
*    FIND NEXT BLANK AFTER FIRST NON-BLANK                              00750000
*                                                                       00760000
         LR    R7,R1                   FIRST NON-BLANK CHARACTER        00770000
         LR    R8,INREG                BEGINNING OF FIELD ADDRESS       00780000
         AR    R8,LGTHREG              ADD LENGTH OF FIELD              00790000
         SR    R8,R7                   SUBTRACT NON-BLANK CHAR ADDRESS  00800000
         BCTR  R8,0                    DECREASE BY 1 FOR EXECUTE        00810000
         EX    R8,FINDBL               FIND NEXT BLANK                  00820000
         BZ    RETURN                     IF NO OTHER BLANKS, RETURN    00830000
*                                                                       00840000
*    MAKE SURE NO OTHER NON-BLANKS FOLLOW                               00850000
*                                                                       00860000
         LR    R7,R1                   TRAILING BLANK CHARACTER         00870000
         LR    R8,INREG                BEGINNING OF FIELD ADDRESS       00880000
         AR    R8,LGTHREG              ADD LENGTH OF FIELD              00890000
         SR    R8,R7                   SUBTRACT TRAILING BLANK ADDRESS  00900000
         BCTR  R8,0                    DECREASE BY 1 FOR EXECUTE        00910000
         EX    R8,FINDNB               LOOK FOR NEXT NON-BLANK          00920000
         BZ    RETURN                     IF NONE FOUND, RETURN         00930000
*                                                                       00940000
*    RETURN CODE OF "8" INDICATES EMBEDDED BLANKS DETECTED              00950000
*                                                                       00960000
ERROR    LA    R15,8                    RETURN CODE OF 8                00970000
*                                                                       00980000
*    RETURN TO CALLER WITH RETURN CODE IN REGISTER 15                   00990000
*                                                                       01000000
RETURN   RETURN (14,12),RC=(15)                                         01010000
*                                                                       01020000
*    TRT PERFORMED BY EXECUTE FROM ABOVE TO FIND NON-BLANKS             01030000
*                                                                       01040000
FINDNB   TRT   0(0,R7),TABLENB          SCAN FOR NON-BLANK CHARACTERS   01050000
*                                                                       01060000
*    TRT PERFORMED BY EXECUTE FROM ABOVE TO FIND BLANKS                 01070000
*                                                                       01080000
FINDBL   TRT   0(0,R7),TABLEBL          SCAN FOR BLANK CHARACTER        01090000
         SPACE                                                          01100000
* ******************************************************************* * 01110000
* *************************** CONSTANTS ***************************** * 01120000
* ******************************************************************* * 01130000
TABLENB  DC    64X'01'                 TABLE TO FIND NON-BLANKS         01140000
         DC    X'00'                                                    01150000
         DC    191X'01'                                                 01160000
TABLEBL  DC    64X'00'                 TABLE TO FIND BLANKS             01170000
         DC    X'01'                                                    01180000
         DC    191X'00'                                                 01190000
         LTORG                                                          01200000
         EJECT                                                          01210000
* ******************************************************************* * 01220000
* ***************************** EQUATES ***************************** * 01230000
* ******************************************************************* * 01240000
R0       EQU   0                       REGISTER 0                       01250000
R1       EQU   1                       REGISTER 1                       01260000
R2       EQU   2                       REGISTER 2                       01270000
R3       EQU   3                       REGISTER 3                       01280000
R4       EQU   4                       REGISTER 4                       01290000
INREG    EQU   5                       INPUT FIELD                      01300000
LGTHREG  EQU   6                       INPUT FIELD LENGTH               01310000
R7       EQU   7                       REGISTER 7                       01320000
R8       EQU   8                       REGISTER 8                       01330000
R9       EQU   9                       REGISTER 9                       01340000
R10      EQU   10                      REGISTER 10                      01350000
R11      EQU   11                      REGISTER 11                      01360000
BASE     EQU   12                      BASE REGISTER                    01370000
R13      EQU   13                      REGISTER 13                      01380000
R14      EQU   14                      REGISTER 14                      01390000
R15      EQU   15                      REGISTER 15                      01400000
         END                                                            01410000
./       ADD   NAME=OFMTHEX
         TITLE 'OFMTHEX - CONVERT HEX DATA TO PRINTABLE CHARACTERS'     00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    OOOOO  FFFFFFF M     M TTTTTTTT HH   HH EEEEEE  XX   XX          * 00040000
*   OO   OO FF      MM   MM    TT    HH   HH EE      XX   XX          * 00050000
*   OO   OO FF      MMM MMM    TT    HH   HH EE       XX XX           * 00060000
*   OO   OO FFFFF   MMMMMMM    TT    HHHHHHH EEEE      XXX            * 00070000
*   OO   OO FF      MM M MM    TT    HH   HH EE        XXX            * 00080000
*   OO   OO FF      MM   MM    TT    HH   HH EE       XX XX           * 00090000
*   OO   OO FF      MM   MM    TT    HH   HH EE      XX   XX          * 00100000
*    OOOOO  FF      MM   MM    TT    HH   HH EEEEEEE XX   XX          * 00110000
*                                                                     * 00120000
* ******************************************************************* * 00130000
* THIS SUBROUTINE READS AN INPUT FIELD AND CONVERTS EACH BYTE TO      * 00140000
* THE CORRESPONDING CHARACTER REPRESENTATION OF THE 2 HEX DIGITS      * 00150000
* THAT CORRESPOND TO THE ORIGINAL BYTE.                               * 00160000
*                                                                     * 00170000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00180000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00190000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00200000
*                                                                     * 00210000
* THREE FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:               * 00220000
*                                                                     * 00230000
*   1. A FIELD OF VARYING LENGTH CONTAINING THE INPUT CHARACTERS,     * 00240000
*   2. A 2 BYTE FIELD (IN BINARY FORMAT) CONTAINING THE LENGTH OF     * 00250000
*      THE INPUT FIELD, AND                                           * 00260000
*   3. A FIELD TO CONTAIN THE GENERATED OUTPUT.                       * 00270000
*                                                                     * 00280000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00290000
*                                                                     * 00300000
*              CALL OFMTHEX,(INFIELD,INLENGTH,OUTFIELD)               * 00310000
*                 . . .                                               * 00320000
*     INFIELD  DS   XL5'C180F0F140'                                   * 00330000
*     INLENGTH DS   H'5'                                              * 00340000
*     OUTFIELD DS   CL10'C180F0F140'                                  * 00350000
*                                                                     * 00360000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00370000
*                                                                     * 00380000
*     01  INPUT-FIELD           PIC X(5) VALUE X'C180F0F140'.         * 00390000
*     01  INPUT-FIELD-LENGTH    PIC S9(4) COMP VALUE 5.               * 00400000
*     01  OUTPUT-FIELD          PIC X(10).                            * 00410000
*                                                                     * 00420000
*     CALL 'OFMTHEX' USING INPUT-FIELD, INPUT-FIELD-LENGTH,           * 00430000
*                          OUTPUT-FIELD.                              * 00440000
*                                                                     * 00450000
* NOTE: THE SIZE OF THE OUTPUT FIELD MUST BE TWICE THAT OF THE INPUT  * 00460000
*       FIELD.                                                        * 00470000
*                                                                     * 00480000
* POSSIBLE RETURN CODE VALUES:                                        * 00490000
*     0 - FIELD SUCCESSFULLY CONVERTED                                * 00500000
* ******************************************************************* * 00510000
* ******************************************************************* * 00520000
         EJECT                                                          00530000
         PRINT NOGEN                                                    00540000
OFMTHEX  CSECT                                                          00550000
         EYEC  'CONVERT HEX DIGITS TO PRINTABLE CHARACTERS'             00580000
BEGIN    SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00590000
*                                                                       00600000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00610000
         USING *,BASE                  ASSUME BASE REGISTER             00620000
*                                                                       00630000
         LM    INREG,OUTREG,0(R1)      LOAD ADDRESSES OF PARAMETERS     00640000
*                                                                       00650000
         SR    R15,R15                 ASSUME RETURN CODE OF ZERO       00660000
*                                                                       00670000
         LH    LGTHREG,0(,LGTHREG)     LOAD FIELD LENGTH                00680000
         LTR   LGTHREG,LGTHREG         IS INPUT FIELD LENGTH ZERO?      00690000
         BZ    RETURN                     IF YES, RETURN TO CALLER      00700000
*                                                                       00710000
*    OUTER LOOP EXECUTES 1 PASS FOR EACH INPUT CHARACTER                00720000
*                                                                       00730000
BYTELOOP LA    R4,2                    CONVERT 2 NIBBLES (1 BYTE)       00740000
         ICM   R3,B'1000',0(INREG)     GET 1 BYTE TO CONVERT            00750000
*                                                                       00760000
*    INNER LOOP EXECUTES 2 PASSES FOR EACH INPUT CHARACTER              00770000
*                                                                       00780000
NIBLLOOP SR    R2,R2                   CLEAR EVEN WORK REGISTER         00790000
         SLDL  R2,4                    SHIFT LEFT 1 NIBBLE              00800000
         C     R2,=F'10'               COMPARE VALUE WITH DECIMAL 10    00810000
         BM    DIGITS                  BRANCH IF DIGIT 0-9              00820000
         LA    R2,X'C0'-9(,R2)         ADD X'C0'-9 TO REGISTER 2        00830000
         B     SAVENIBL                STORE THE CHARACTER              00840000
DIGITS   LA    R2,X'F0'(,R2)           ADD X'F0' TO REGISTER 2          00850000
SAVENIBL STC   R2,0(,OUTREG)           STORE CONVERTED BYTE             00860000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              00870000
         BCT   R4,NIBLLOOP             CONVERT 2ND NIBBLE               00880000
*                                                                       00890000
         LA    INREG,1(,INREG)         BUMP INPUT ADDRESS               00900000
         BCT   LGTHREG,BYTELOOP        CONVERT NEXT BYTE                00910000
*                                                                       00920000
*    RETURN TO CALLER WITH RETURN CODE IN REGISTER 15                   00930000
*                                                                       00940000
RETURN   RETURN (14,12),RC=(15)                                         00950000
*                                                                       00960000
* ******************************************************************* * 00970000
* *************************** CONSTANTS ***************************** * 00980000
* ******************************************************************* * 00990000
         LTORG                                                          01000000
         EJECT                                                          01010000
* ******************************************************************* * 01020000
* ***************************** EQUATES ***************************** * 01030000
* ******************************************************************* * 01040000
R0       EQU   0                       REGISTER 0                       01050000
R1       EQU   1                       REGISTER 1                       01060000
R2       EQU   2                       REGISTER 2                       01070000
R3       EQU   3                       REGISTER 3                       01080000
R4       EQU   4                       REGISTER 4                       01090000
INREG    EQU   5                       INPUT FIELD                      01100000
LGTHREG  EQU   6                       INPUT FIELD LENGTH               01110000
OUTREG   EQU   7                       OUTPUT FIELD                     01120000
R8       EQU   8                       REGISTER 8                       01130000
R9       EQU   9                       REGISTER 9                       01140000
R10      EQU   10                      REGISTER 10                      01150000
R11      EQU   11                      REGISTER 11                      01160000
BASE     EQU   12                      BASE REGISTER                    01170000
R13      EQU   13                      REGISTER 13                      01180000
R14      EQU   14                      REGISTER 14                      01190000
R15      EQU   15                      REGISTER 15                      01200000
         END                                                            01210000
./       ADD   NAME=OFMTMONY
         TITLE 'OFMTMONY - FORMAT MONETARY AMOUNT IN WORDS'             00010000
* ******************************************************************* * 00020000
*                                                                     * 00030000
*    OOOOO  FFFFFFF M     M TTTTTTTT M     M  OOOOO  NN   NN YY   YY  * 00040000
*   OO   OO FF      MM   MM    TT    MM   MM OO   OO NNN  NN YY   YY  * 00050000
*   OO   OO FF      MMM MMM    TT    MMM MMM OO   OO NNN  NN YY   YY  * 00060000
*   OO   OO FFFFF   MMMMMMM    TT    MMMMMMM OO   OO NNNN NN  YY YY   * 00070000
*   OO   OO FF      MM M MM    TT    MM M MM OO   OO NN NNNN   YYY    * 00080000
*   OO   OO FF      MM   MM    TT    MM   MM OO   OO NN  NNN   YY     * 00090000
*   OO   OO FF      MM   MM    TT    MM   MM OO   OO NN  NNN   YY     * 00100000
*    OOOOO  FF      MM   MM    TT    MM   MM  OOOOO  NN   NN   YY     * 00110000
*                                                                     * 00120000
*********************************************************************** 00130000
*********************************************************************** 00140000
* THIS SUBROUTINE CONVERTS A NUMERIC INPUT FIELD INTO THE EQUIVALENT  * 00150000
* WRITTEN WORDS DESCRIBING THE VALUE (SUCH AS USED IN WRITING CHECKS) * 00160000
*                                                                     * 00170000
* NONE OF THE INITIALIZED VARIABLES ARE CHANGED DURING THE ROUTINE'S  * 00180000
* EXECUTION AND THERE ARE NO INTERNAL DATA FIELDS. ALL MANIPULATION   * 00190000
* IS DONE THROUGH REGISTERS. THE ROUTINE IS COMPLETELY REENTRANT.     * 00200000
*                                                                     * 00210000
* TWO FIELDS ARE PASSED AS PARAMETERS TO THE ROUTINE:                 * 00220000
*                                                                     * 00230000
*   1) A 13 BYTE NUMERIC INPUT FIELD (IN ZONED-DECIMAL FORMAT), AND   * 00240000
*   2) A 160 BYTE BUFFER WHICH WILL CONTAIN THE FORMATTED OUTPUT      * 00250000
*      (OUTPUT WILL BE LEFT JUSTIFIED AND PADDED WITH ASTERISKS).     * 00260000
*                                                                     * 00270000
* THE UPPER LIMIT FOR THE INPUT VALUE IS 99,999,999,999.99 = NINETY-  * 00280000
* NINE BILLION, NINE HUNDRED AND NINETY-NINE MILLION, NINE HUNDRED    * 00290000
* AND NINETY-NINE THOUSAND, NINE HUNDRED AND NINETY-NINE DOLLARS AND  * 00300000
* 99 CENTS. THE LONGEST OUTPUT STRING POSSIBLE IS FOR THE AMOUNT OF   * 00310000
* 77,777,777,777.77 AND IS 158 CHARACTERS.                            * 00320000
*                                                                     * 00330000
* SUGGESTED CALLING SYNTAX FOR ALC CALLERS:                           * 00340000
*                                                                     * 00350000
*              CALL OFMTMONY,(VALUEIN,VALUEOUT)                       * 00360000
*                 . . .                                               * 00370000
*     VALUEIN  DS   ZL13'0000000152995'                               * 00380000
*     VALUEOUT DS   CL160' '                                          * 00390000
*                                                                     * 00400000
* SUGGESTED CALLING SYNTAX FOR COBOL CALLERS:                         * 00410000
*                                                                     * 00420000
*     01  OFMTMONY-PARAMETERS.                                        * 00430000
*         02  VALUE-INPUT   PIC S9(11)V99 VALUE +1529.95.             * 00440000
*         02  VALUE-OUTPUT  PIC X(160).                               * 00450000
*                                                                     * 00460000
*         CALL 'OFMTMONY' USING VALUE-INPUT, VALUE-OUTPUT.            * 00470000
*                                                                     * 00480000
* THE POSSIBLE VALUES FOR THE RETURN CODE FIELD ARE:                  * 00490000
*                                                                     * 00500000
*     0 - FIELD SUCCESSFULLY CONVERTED                                * 00510000
*     4 - INPUT WAS NEGATIVE, VOID MESSAGE RETURNED                   * 00520000
*     8 - INPUT CONTAINED NON-NUMERIC CHARACTERS                      * 00530000
*********************************************************************** 00540000
*********************************************************************** 00550000
         EJECT                                                          00560000
         PRINT NOGEN                                                    00570000
OFMTMONY CSECT                                                          00580000
         EYEC  'FORMAT MONEYTARY AMOUNT IN WORDS'                       00610000
BEGIN    SAVE  (14,12)                 SAVE CALLER'S REGISTERS          00620000
*                                                                       00630000
         BALR  BASE,0                  ESTABLISH BASE REGISTER          00640000
         USING *,BASE                  ASSUME BASE REGISTER             00650000
*                                                                       00660000
         LM    INREG,OUTREG,0(R1)      LOAD ADDRESSES OF PARAMETERS     00670000
*                                                                       00680000
*    INITIALIZE RETURN CODE                                             00690000
*                                                                       00700000
         SR    R15,R15                 ASSUME GOOD RETURN               00710000
*                                                                       00720000
*    TEST FOR NON-NUMERIC CHARACTERS IN INPUT FIELD                     00730000
*                                                                       00740000
         LR    R2,INREG                ADDRESS INPUT FIELD              00750000
         LA    R3,12                   FIELD LENGTH MINUS 1             00760000
P1NLOOP  CLI   0(R2),X'F0'             TEST LESS THAN C'0'              00770000
         BL    P1NERR                  IF YES, FIELD CONTAINS BAD DATA  00780000
         CLI   0(R2),X'F9'             TEST GREATER THAN C'9'           00790000
         BH    P1NERR                  IF YES, FIELD CONTAINS BAD DATA  00800000
         LA    R2,1(0,R2)              ADDRESS NEXT BYTE                00810000
         BCT   R3,P1NLOOP              CONTINUE TESTING                 00820000
         IC    R3,0(,R2)               LOAD RIGHT-MOST CHARACTER        00830000
         LR    R2,R3                   COPY INTO R2                     00840000
         N     R3,=F'15'               ISOLATE DIGIT PORTION            00850000
         CH    R3,=H'9'                TEST GREATER THAN 9              00860000
         BH    P1NERR                  IF YES, FIELD CONTAINS BAD DATA  00870000
         SRL   R2,4                    ISOLATE ZONE PORTION             00880000
         CH    R2,=H'12'               TEST FOR 'C' ZONE                00890000
         BE    P1OK2                   IF YES, FIELD IS VALID NUMERIC   00900000
         CH    R2,=H'13'               TEST FOR 'D' ZONE                00910000
         BE    P1OK1                   IF YES, FIELD IS VALID NUMERIC   00920000
         CH    R2,=H'15'               TEST FOR 'F' ZONE                00930000
         BE    P1OK2                   IF YES, FIELD IS VALID NUMERIC   00940000
*                                                                       00950000
*    INPUT AMOUNT CONTAINED NON-NUMERIC CHARACTER                       00960000
*                                                                       00970000
P1NERR   LA    R15,8                   INDICATE BAD DATA                00980000
         B     RETURN                  AND RETURN TO CALLER             00990000
*                                                                       01000000
*    SET RETURN CODE TO INDICATE NEGATIVE INPUT VALUE                   01010000
*                                                                       01020000
P1OK1    LA    R15,4                   SET RETURN CODE TO '4'           01030000
*                                                                       01040000
*    SAVE LOW ORDER BYTE OF INPUT VALUE AND CLEAR ANY SIGN              01050000
*                                                                       01060000
P1OK2    IC    R11,12(,INREG)          SAVE LOW ORDER BYTE              01070000
         OI    12(INREG),X'F0'         CLEAR SIGN NIBBLE                01080000
*                                                                       01090000
*    INITIALIZE REGISTERS FOR CONVERSION                                01100000
*                                                                       01110000
         SR    WLREG,WLREG             CLEAR WORD LENGTH REGISTER       01120000
         ICM   FLAGS,B'0100',=C' '     SET SEPARATOR TO SPACE           01130000
         ICM   FLAGS,B'0010',=C'S'     DEFAULT PLURAL DOLLARS           01140000
         CLC   0(11,INREG),ZEROS1+3    IS DOLLAR AMOUNT ONLY 1?         01150000
         BNE   INIT1                   NO, USE PLURAL "DOLLARS"         01160000
         ICM   FLAGS,B'0010',=C' '     INDICATE SINGULAR DOLLAR         01170000
INIT1    ICM   FLAGS,B'0001',=C'S'     DEFAULT PLURAL CENTS             01180000
         CLC   11(2,INREG),ZEROS1+12   IS CENTS AMOUNT ONLY 1?          01190000
         BNE   INIT2                   NO, USE PLURAL "CENTS"           01200000
         ICM   FLAGS,B'0001',=C' '     INDICATE SINGULAR CENT           01210000
*                                                                       01220000
*    FILL OUTPUT BUFFER WITH ASTERISKS                                  01230000
*                                                                       01240000
INIT2    MVI   0(OUTREG),C'*'          INITIALIZE OUTPUT                01250000
         MVC   1(159,OUTREG),0(OUTREG) AREA OF 160 BYTES                01260000
*                                                                       01270000
*    IF INPUT WAS NEGATIVE, RETURN "V O I D"                            01280000
*                                                                       01290000
         LTR   R15,R15                 WAS INPUT NEGATIVE?              01300000
         BNZ   VOIDCK                  YES, RETURN "V O I D"            01310000
*                                                                       01320000
         CLC   0(13,INREG),ZEROS1      IS ENTIRE AMOUNT ZERO?           01330000
         BNE   $DOLLARS                NO, GO BEGIN CONVERSION          01340000
*                                                                       01350000
*    IF AMOUNT WAS NEGATIVE OR ZERO, RETURN "V O I D"                   01360000
*                                                                       01370000
VOIDCK   LA    WORDREG,VOID            "V O I D"                        01380000
         ICM   FLAGS,B'0100',=C'!'     INDICATE NO SEPARATOR FOLLOWS    01390000
         BAL   SECBAL,PUTWORD                                           01400000
         B     RESTORE                 RESTORE INPUT VALUE AND RETURN   01410000
*                                                                       01420000
*    IF THE ENTIRE DOLLAR PORTION OF THE FIELD IS ZEROS, OUTPUT THE     01430000
*    WORD "ONLY" AND JUMP TO PROCESS CENTS AREA                         01440000
*                                                                       01450000
$DOLLARS CLC   0(11,INREG),ZEROS1      IS ENTIRE DOLLAR AMOUNT ZERO?    01460000
         BNE   $BILLCK                 NO, GO CHECK BILLIONS            01470000
*                                                                       01480000
         LA    WORDREG,ONLY            "ONLY"                           01490000
         BAL   SECBAL,PUTWORD                                           01500000
         LA    INREG,11(,INREG)        ADDRESS CENTS                    01510000
         B     $CENTS                  GO FORMAT CENTS                  01520000
*                                                                       01530000
*    IF THE 2 PLACES THAT CONTAIN THE BILLIONS PORTION ARE ZERO,        01540000
*    JUMP TO PROCESS THE MILLIONS PORTION                               01550000
*                                                                       01560000
$BILLCK  CLC   0(2,INREG),ZEROS1       IS BILLIONS AMOUNT ZERO?         01570000
         BNE   $BILLGO                 NO, CONTINUE                     01580000
*                                                                       01590000
         LA    INREG,2(,INREG)         ADDRESS MILLIONS                 01600000
         B     $MILLCK                 GO CHECK MILLIONS                01610000
*                                                                       01620000
$BILLGO  ICM   FLAGS,B'1000',=C'Y'     INDICATE BILLIONS GROUP          01630000
         BAL   PRIBAL,$GROUP           PROCESS GROUP                    01640000
         ICM   FLAGS,B'1000',=C'N'     RESET BILLIONS GROUP INDICATOR   01650000
*                                                                       01660000
         CLC   0(9,INREG),ZEROS1       IS REMAINDER OF DOLLARS ZERO?    01670000
         BE    $BILL2                  YES, LEAVE SEPARATOR AS SPACE    01680000
*                                                                       01690000
         CLC   0(6,INREG),ZEROS1       ARE NEXT TWO GROUPS ZERO?        01700000
         BNE   $BILL1                  NO, INSERT COMMA                 01710000
*                                                                       01720000
         ICM   FLAGS,B'1000',=C'A'     FLAG TO INSERT "AND"             01730000
         B     $BILL2                  CONTINUE                         01740000
*                                                                       01750000
$BILL1   ICM   FLAGS,B'0100',=C','     CHANGE SEPARATOR TO COMMA        01760000
*                                                                       01770000
$BILL2   LA    WORDREG,BILLION         "BILLION"                        01780000
         BAL   SECBAL,PUTWORD                                           01790000
*                                                                       01800000
         CLM   FLAGS,B'0100',=C','     IS SEPARATOR A COMMA?            01810000
         BNE   $BILL3                  NO, GO CHECK "AND" FLAG          01820000
*                                                                       01830000
         MVI   0(OUTREG),C' '          INSERT SPACE                     01840000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              01850000
         ICM   FLAGS,B'0100',=C' '     CHANGE SEPARATOR TO SPACE        01860000
         B     $MILLCK                 GO CHECK MILLIONS                01870000
*                                                                       01880000
$BILL3   CLM   FLAGS,B'1000',=C'A'     IS "AND" FLAG SET?               01890000
         BNE   $MILLCK                 NO, GO CHECK MILLIONS            01900000
*                                                                       01910000
         LA    WORDREG,AND             "AND"                            01920000
         BAL   SECBAL,PUTWORD                                           01930000
         ICM   FLAGS,B'1000',=C'N'     RESET "AND" FLAG                 01940000
*                                                                       01950000
*    IF THE 3 PLACES THAT CONTAIN THE MILLIONS PORTION ARE ZERO,        01960000
*    JUMP TO PROCESS THE THOUSANDS PORTION                              01970000
*                                                                       01980000
$MILLCK  CLC   0(3,INREG),ZEROS1       IS MILLIONS AMOUNT ZERO?         01990000
         BNE   $MILLGO                 NO, CONTINUE                     02000000
*                                                                       02010000
         LA    INREG,3(,INREG)         ADDRESS THOUSANDS                02020000
         B     $THOUCK                 GO CHECK THOUSANDS               02030000
*                                                                       02040000
$MILLGO  BAL   PRIBAL,$GROUP           PROCESS GROUP                    02050000
*                                                                       02060000
         CLC   0(6,INREG),ZEROS1       IS REMAINDER OF DOLLARS ZERO?    02070000
         BE    $MILL2                  YES, LEAVE SEPARATOR AS SPACE    02080000
*                                                                       02090000
         CLC   0(3,INREG),ZEROS1       IS NEXT GROUP ZERO?              02100000
         BNE   $MILL1                  NO, INSERT COMMA                 02110000
*                                                                       02120000
         ICM   FLAGS,B'1000',=C'A'     FLAG TO INSERT "AND"             02130000
         B     $MILL2                  CONTINUE                         02140000
*                                                                       02150000
$MILL1   ICM   FLAGS,B'0100',=C','     CHANGE SEPARATOR TO COMMA        02160000
*                                                                       02170000
$MILL2   LA    WORDREG,MILLION         "MILLION"                        02180000
         BAL   SECBAL,PUTWORD                                           02190000
*                                                                       02200000
         CLM   FLAGS,B'0100',=C','     IS SEPARATOR A COMMA?            02210000
         BNE   $MILL3                  NO, GO CHECK "AND" FLAG          02220000
*                                                                       02230000
         MVI   0(OUTREG),C' '          INSERT SPACE                     02240000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              02250000
         ICM   FLAGS,B'0100',=C' '     CHANGE SEPARATOR TO SPACE        02260000
         B     $THOUCK                 GO CHECK THOUSANDS               02270000
*                                                                       02280000
$MILL3   CLM   FLAGS,B'1000',=C'A'     IS "AND" FLAG SET?               02290000
         BNE   $THOUCK                 NO, GO CHECK THOUSANDS           02300000
*                                                                       02310000
         LA    WORDREG,AND             "AND"                            02320000
         BAL   SECBAL,PUTWORD                                           02330000
         ICM   FLAGS,B'1000',=C'N'     RESET "AND" FLAG                 02340000
*                                                                       02350000
*    IF THE 3 PLACES THAT CONTAIN THE THOUSANDS PORTION ARE ZERO,       02360000
*    JUMP TO PROCESS THE HUNDREDS PORTION                               02370000
*                                                                       02380000
$THOUCK  CLC   0(3,INREG),ZEROS1       IS THOUSANDS AMOUNT ZERO?        02390000
         BNE   $THOUGO                 NO, CONTINUE                     02400000
*                                                                       02410000
         LA    INREG,3(,INREG)         ADDRESS HUNDREDS                 02420000
         B     $HUNDCK                 GO CHECK HUNDREDS                02430000
*                                                                       02440000
$THOUGO  BAL   PRIBAL,$GROUP           PROCESS GROUP                    02450000
*                                                                       02460000
         CLC   0(3,INREG),ZEROS1       IS REMAINDER OF DOLLARS ZERO?    02470000
         BE    $THOU2                  YES, LEAVE SEPARATOR AS SPACE    02480000
*                                                                       02490000
         CLC   0(1,INREG),ZEROS1       IS HUNDREDS PLACE ZERO?          02500000
         BNE   $THOU1                  NO, CHANGE SEPARATOR TO COMMA    02510000
*                                                                       02520000
         ICM   FLAGS,B'1000',=C'A'     FLAG TO INSERT "AND"             02530000
         B     $THOU2                  CONTINUE                         02540000
*                                                                       02550000
$THOU1   ICM   FLAGS,B'0100',=C','     CHANGE SEPARATOR TO COMMA        02560000
*                                                                       02570000
$THOU2   LA    WORDREG,THOUSAND        "THOUSAND"                       02580000
         BAL   SECBAL,PUTWORD                                           02590000
*                                                                       02600000
         CLM   FLAGS,B'0100',=C','     IS SEPARATOR A COMMA?            02610000
         BNE   $THOU3                  NO, GO CHECK "AND" FLAG          02620000
*                                                                       02630000
         MVI   0(OUTREG),C' '          INSERT SPACE                     02640000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              02650000
         ICM   FLAGS,B'0100',=C' '     CHANGE SEPARATOR TO SPACE        02660000
         B     $HUNDCK                 GO CHECK HUNDREDS                02670000
*                                                                       02680000
$THOU3   CLM   FLAGS,B'1000',=C'A'     IS "AND" FLAG SET?               02690000
         BNE   $HUNDCK                 NO, GO CHECK HUNDREDS            02700000
*                                                                       02710000
         LA    WORDREG,AND             "AND"                            02720000
         BAL   SECBAL,PUTWORD                                           02730000
         ICM   FLAGS,B'1000',=C'N'     RESET "AND" FLAG                 02740000
*                                                                       02750000
*    IF THE 3 PLACES THAT CONTAIN THE HUNDREDS PORTION ARE ZERO,        02760000
*    JUMP TO FINISH THE DOLLARS PORTION                                 02770000
*                                                                       02780000
$HUNDCK  CLC   0(3,INREG),ZEROS1       IS HUNDREDS AMOUNT ZERO?         02790000
         BNE   $HUNDGO                 NO, CONTINUE                     02800000
*                                                                       02810000
         LA    INREG,3(,INREG)         ADDRESS CENTS GROUP              02820000
         B     $DFINI                  GO PUT "DOLLARS"                 02830000
*                                                                       02840000
$HUNDGO  BAL   PRIBAL,$GROUP           PROCESS GROUP                    02850000
*                                                                       02860000
*    FINISH THE DOLLARS PORTION BY DETERMINING IF THE WORD              02870000
*    "DOLLARS" SHOULD BE SINGULAR OR PLURAL                             02880000
*                                                                       02890000
$DFINI   CLM   FLAGS,B'0010',=C'S'     IS DOLLARS AMOUNT PLURAL?        02900000
         BE    $DFINI0                 YES, USE PLURAL                  02910000
         LA    WORDREG,DOLLAR          "DOLLAR"                         02920000
         B     $DFINI1                                                  02930000
$DFINI0  LA    WORDREG,DOLLARS         "DOLLARS"                        02940000
$DFINI1  BAL   SECBAL,PUTWORD                                           02950000
*                                                                       02960000
*    CONNECT DOLLARS AND CENTS WITH "AND"                               02970000
*                                                                       02980000
         LA    WORDREG,AND             "AND"                            02990000
         BAL   SECBAL,PUTWORD                                           03000000
*                                                                       03010000
*    IF CENTS PORTION IS ZERO, OUTPUT "NO CENTS"                        03020000
*                                                                       03030000
$CENTS   CLC   0(2,INREG),ZEROS1       IS CENTS ZERO?                   03040000
         BNE   $CENTS1                 NO, FORMAT DIGITS                03050000
*                                                                       03060000
         LA    WORDREG,NO              "NO"                             03070000
         BAL   SECBAL,PUTWORD                                           03080000
         B     $CFINI                  GO FINISH                        03090000
*                                                                       03100000
*    CENTS PORTION WASN'T ZERO, SO OUTPUT DIGITS OF CENTS               03110000
*    ZERO SUPPRESSING THE FIRST DIGIT                                   03120000
*                                                                       03130000
$CENTS1  CLI   0(INREG),C'0'           IS FIRST DIGIT ZERO?             03140000
         BE    $CENTS2                 YES, OUTPUT SECOND DIGIT         03150000
*                                                                       03160000
         MVC   0(1,OUTREG),0(INREG)    OUTPUT FIRST DIGIT               03170000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              03180000
*                                                                       03190000
$CENTS2  MVC   0(1,OUTREG),1(INREG)    OUTPUT SECOND DIGIT              03200000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              03210000
*                                                                       03220000
         MVI   0(OUTREG),C' '          INSERT SPACE                     03230000
         LA    OUTREG,1(,OUTREG)       BUMP OUTPUT ADDRESS              03240000
*                                                                       03250000
*    FINISH THE CENTS PORTION BY DETERMINING IF THE WORD                03260000
*    "CENTS" SHOULD BE SINGULAR OR PLURAL                               03270000
*                                                                       03280000
$CFINI   CLM   FLAGS,B'0001',=C'S'     IS CENTS AMOUNT PLURAL?          03290000
         BE    $CFINI0                 YES, USE PLURAL                  03300000
         LA    WORDREG,CENT            "CENT"                           03310000
         B     $CFINI1                                                  03320000
$CFINI0  LA    WORDREG,CENTS           "CENTS"                          03330000
$CFINI1  ICM   FLAGS,B'0100',=C'!'     INDICATE NO SEPARATOR FOLLOWS    03340000
         BAL   SECBAL,PUTWORD                                           03350000
*                                                                       03360000
*    RESTORE LOW ORDER BYTE OF INPUT VALUE                              03370000
*                                                                       03380000
RESTORE  L     R2,0(,R1)               ADDRESS INPUT FIELD              03390000
         STC   R11,12(,R2)             RESTORE SAVED BYTE               03400000
*                                                                       03410000
*    RETURN TO CALLER WITH RETURN CODE IN R15                           03420000
*                                                                       03430000
RETURN   RETURN (14,12),RC=(15)                                         03440000
*                                                                       03450000
*     EACH GROUP OF 3 DIGITS TO THE LEFT OF THE DECIMAL POINT           03460000
*     ARE PROCESSED WITH THE CODE BELOW. ONLY THE BILLIONS GROUP        03470000
*     REQUIRES A UNIQUE TEST AS THERE IS NO HUNDRED BILLION BYTE        03480000
*                                                                       03490000
$GROUP   CLM   FLAGS,B'1000',=C'Y'     IS THIS BILLIONS GROUP           03500000
         BE    $GTENS                  YES, SKIP HUNDRED'S DIGIT        03510000
*                                                                       03520000
         CLI   0(INREG),C'0'           IS HUNDREDS DIGIT ZERO?          03530000
         BNE   $GHUND                  NO, CONTINUE                     03540000
*                                                                       03550000
         LA    INREG,1(,INREG)         ADDRESS TEN'S DIGIT              03560000
         B     $GTENS                  GO TEST TEN'S DIGIT              03570000
*                                                                       03580000
*    OUTPUT THE EQUIVALENT WORD FOR THE HUNDREDS DIGIT                  03590000
*                                                                       03600000
$GHUND   IC    DIGREG,0(,INREG)        GET DIGIT                        03610000
         LA    TABREG,UNITS            UNITS TABLE                      03620000
         LA    TELENREG,6              ENTRY IS 6 CHARACTERS LONG       03630000
         BAL   SECBAL,PUTDIGIT                                          03640000
*                                                                       03650000
         LA    WORDREG,HUNDRED         "HUNDRED"                        03660000
         BAL   SECBAL,PUTWORD                                           03670000
*                                                                       03680000
         LA    INREG,1(,INREG)         ADDRESS TEN'S DIGIT              03690000
*                                                                       03700000
         CLC   0(2,INREG),ZEROS1       ARE TENS AND UNITS ZERO          03710000
         BNE   $GHUND0                 NO, MUST INSERT "AND"            03720000
*                                                                       03730000
         LA    INREG,2(,INREG)         ADDRESS NEXT GROUP               03740000
         B     $GROUPX                 JUMP TO COMMON SUBROUTINE EXIT   03750000
*                                                                       03760000
$GHUND0  LA    WORDREG,AND             "AND"                            03770000
         BAL   SECBAL,PUTWORD                                           03780000
*                                                                       03790000
$GTENS   CLI   0(INREG),C'0'           IS TENS DIGIT ZERO?              03800000
         BNE   $GTENS0                 NO, CONTINUE                     03810000
*                                                                       03820000
         LA    INREG,1(,INREG)         ADDRESS UNIT'S DIGIT             03830000
         B     $GUNITS                 GO TEST UNIT'S DIGIT             03840000
*                                                                       03850000
$GTENS0  CLI   0(INREG),C'1'           IS TEN'S DIGIT '1'?              03860000
         BNE   $GTENSR                 NO, NORMAL TEN'S PROCESS         03870000
*                                                                       03880000
         CLI   1(INREG),C'0'           IS UNIT'S DIGIT '0' (10 EVEN)?   03890000
         BE    $GTENSR                 YES, NORMAL TEN'S PROCESS        03900000
*                                                                       03910000
*    OUTPUT THE EQUIVALENT WORD FOR THE TEENS DIGIT                     03920000
*                                                                       03930000
         IC    DIGREG,1(,INREG)        GET DIGIT (UNIT'S FOR TEEN'S)    03940000
         LA    TABREG,TEENS            TEENS TABLE                      03950000
         LA    TELENREG,10             ENTRY IS 10 CHARACTERS LONG      03960000
         BAL   SECBAL,PUTDIGIT                                          03970000
*                                                                       03980000
         LA    INREG,2(,INREG)         ADDRESS NEXT GROUP               03990000
         B     $GROUPX                 JUMP TO COMMON SUBROUTINE EXIT   04000000
*                                                                       04010000
$GTENSR  CLI   1(INREG),C'0'           IS UNIT'S DIGIT '0' (10 EVEN)?   04020000
         BE    $GTENSRX                YES, NO HYPHEN SEPARATOR         04030000
*                                                                       04040000
         ICM   FLAGS,B'0100',=C'-'     CHANGE SEPARATOR TO HYPHEN       04050000
*                                                                       04060000
*    OUTPUT THE EQUIVALENT WORD FOR THE EVEN TENS DIGIT                 04070000
*                                                                       04080000
$GTENSRX IC    DIGREG,0(,INREG)        GET DIGIT                        04090000
         LA    TABREG,TENS             TENS TABLE                       04100000
         LA    TELENREG,8              ENTRY IS 8 CHARACTERS LONG       04110000
         BAL   SECBAL,PUTDIGIT                                          04120000
*                                                                       04130000
         ICM   FLAGS,B'0100',=C' '     CHANGE SEPARATOR TO SPACE        04140000
*                                                                       04150000
         LA    INREG,1(,INREG)         ADDRESS UNIT'S DIGIT             04160000
*                                                                       04170000
$GUNITS  CLI   0(INREG),C'0'           IS UNIT'S DIGIT ZERO?            04180000
         BNE   $GUNITS0                NO, CONTINUE                     04190000
*                                                                       04200000
         LA    INREG,1(,INREG)         ADDRESS NEXT GROUP               04210000
         B     $GROUPX                 JUMP TO COMMON SUBROUTINE EXIT   04220000
*                                                                       04230000
*    OUTPUT THE EQUIVALENT WORD FOR THE UNITS DIGIT                     04240000
*                                                                       04250000
$GUNITS0 IC    DIGREG,0(,INREG)        GET DIGIT                        04260000
         LA    TABREG,UNITS            UNITS TABLE                      04270000
         LA    TELENREG,6              ENTRY IS 6 CHARACTERS LONG       04280000
         BAL   SECBAL,PUTDIGIT                                          04290000
*                                                                       04300000
         LA    INREG,1(,INREG)         ADDRESS NEXT GROUP               04310000
*                                                                       04320000
*     THIS IS THE END OF THE GROUP SUBROUTINE                           04330000
*                                                                       04340000
$GROUPX  BR    PRIBAL                  RETURN TO CALLING POINT IN MAIN  04350000
*                                                                       04360000
*    THIS SECONDARY LEVEL SUBROUTINE USES THE VALUE OF THE DIGIT        04370000
*    LOADED INTO REGISTER 9 TO COMPUTE AN OFFSET INTO THE CONSTANT      04380000
*    TABLE AND COPIES THE CONSTANT WORD INTO THE OUTPUT BUFFER          04390000
*                                                                       04400000
PUTDIGIT N     DIGREG,=F'15'           REMOVE SIGN                      04410000
         BCTR  DIGREG,0                DECREASE BY 1 (0 BASED OFFSET)   04420000
         MR    R8,TELENREG             MULTIPLY BY ENTRY LENGTH         04430000
         LA    WORDREG,0(DIGREG,TABREG) LOAD ADDRESS OF DIGIT WORD      04440000
*                                                                       04450000
*    PUTWORD IS NESTED WITHIN PUTDIGIT TO AVOID A THIRD LEVEL CALL      04460000
*    FROM PUTDIGIT, BUT PUTWORD IS CALLED FROM THE MAIN ROUTINE         04470000
*    TO COPY CONTANT WORDS INTO THE OUTPUT BUFFER                       04480000
*                                                                       04490000
PUTWORD  IC    WLREG,0(,WORDREG)       GET LENGTH OF WORD               04500000
PUTLOOP  LA    WORDREG,1(,WORDREG)     BUMP ADDRESS PAST LENGTH         04510000
         LR    R8,WLREG                COPY WORD LENGTH                 04520000
         BCTR  R8,0                    DECREASE BY 1 FOR EXECUTE        04530000
         EX    R8,VARMOVE              MOVE WORD TO OUTPUT              04540000
         LA    OUTREG,0(WLREG,OUTREG)  UPDATE OUTPUT ADDRESS            04550000
         CLM   FLAGS,B'0100',=C'!'     IS SEPARATOR TO BE INSERTED?     04560000
         BE    PUTX                    NO, JUMP TO EXIT                 04570000
         STCM  FLAGS,B'0100',0(OUTREG) INSERT SEPARATOR CHARACTER       04580000
         LA    OUTREG,1(,OUTREG)       UPDATE OUTPUT ADDRESS            04590000
PUTX     BR    SECBAL                  RETURN TO CALLING POINT          04600000
*                                                                       04610000
*     THIS IS THE END OF THE PUTDIGIT / PUTWORD SUBROUTINE              04620000
*                                                                       04630000
VARMOVE  MVC   0(0,OUTREG),0(WORDREG)  MOVE DIGIT WORD                  04640000
*                                                                       04650000
****************************** CONSTANTS ****************************** 04660000
ZEROS1   DC    C'00000000000001'                                        04670000
*                                                                       04680000
*    THE FOLLOWING TABLE CONSISTS OF ENTRIES DESCRIBING WORDS THAT      04690000
*    ARE SELECTED FOR COPYING INTO THE OUTPUT STRING BASED ON THE       04700000
*    INPUT VALUE. EACH TABLE ENTRY IS A ONE BYTE FIELD CONTAINING       04710000
*    THE NUMBER OF BYTES IN THE WORD THAT IS THE REMAINDER OF THE       04720000
*    TABLE ENTRY. THE ORDER OF THE TABLE MUST NOT BE CHANGED.           04730000
*                                                                       04740000
VOID     DC    X'07',CL7'V O I D'                                       04750000
BILLION  DC    X'07',CL7'BILLION'                                       04760000
MILLION  DC    X'07',CL7'MILLION'                                       04770000
THOUSAND DC    X'08',CL8'THOUSAND'                                      04780000
HUNDRED  DC    X'07',CL7'HUNDRED'                                       04790000
DOLLAR   DC    X'06',CL6'DOLLAR'                                        04800000
DOLLARS  DC    X'07',CL7'DOLLARS'                                       04810000
ONLY     DC    X'04',CL4'ONLY'                                          04820000
AND      DC    X'03',CL3'AND'                                           04830000
NO       DC    X'02',CL2'NO'                                            04840000
CENT     DC    X'04',CL4'CENT'                                          04850000
CENTS    DC    X'05',CL5'CENTS'                                         04860000
UNITS    DC    X'03',CL5'ONE  '                                         04870000
         DC    X'03',CL5'TWO  '                                         04880000
         DC    X'05',CL5'THREE'                                         04890000
         DC    X'04',CL5'FOUR '                                         04900000
         DC    X'04',CL5'FIVE '                                         04910000
         DC    X'03',CL5'SIX  '                                         04920000
         DC    X'05',CL5'SEVEN'                                         04930000
         DC    X'05',CL5'EIGHT'                                         04940000
         DC    X'04',CL5'NINE '                                         04950000
TEENS    DC    X'06',CL9'ELEVEN   '                                     04960000
         DC    X'06',CL9'TWELVE   '                                     04970000
         DC    X'08',CL9'THIRTEEN '                                     04980000
         DC    X'08',CL9'FOURTEEN '                                     04990000
         DC    X'07',CL9'FIFTEEN  '                                     05000000
         DC    X'07',CL9'SIXTEEN  '                                     05010000
         DC    X'09',CL9'SEVENTEEN'                                     05020000
         DC    X'08',CL9'EIGHTEEN '                                     05030000
         DC    X'08',CL9'NINETEEN '                                     05040000
TENS     DC    X'03',CL7'TEN    '                                       05050000
         DC    X'06',CL7'TWENTY '                                       05060000
         DC    X'06',CL7'THIRTY '                                       05070000
         DC    X'05',CL7'FORTY  '                                       05080000
         DC    X'05',CL7'FIFTY  '                                       05090000
         DC    X'05',CL7'SIXTY  '                                       05100000
         DC    X'07',CL7'SEVENTY'                                       05110000
         DC    X'06',CL7'EIGHTY '                                       05120000
         DC    X'06',CL7'NINETY '                                       05130000
         LTORG                                                          05140000
* ******************************************************************* * 05150000
* ***************************** EQUATES ***************************** * 05160000
* ******************************************************************* * 05170000
R0       EQU   0                       REGISTER 0                       05180000
R1       EQU   1                       REGISTER 1                       05190000
FLAGS    EQU   2                       TASK FLAGS DURING CONVERSION     05200000
*                                                                       05210000
*    REGISTER 2 IS USED TO CONTAIN INDICATORS WHICH CONTROL THE         05220000
*    PROCESSING. THE POSSIBLE VALUES ARE:                               05230000
*                                                                       05240000
*      B'1000' = 'Y': BILLIONS GROUP IS BEING PROCESSED                 05250000
*      B'1000' = 'A': INSERT "AND" AFTER WORD INSERTION                 05260000
*      B'1000' = 'N': DO NOT INSERT "AND" AFTER WORD INSERTION          05270000
*      B'0100' = ' ': INSERT BLANK AFTER WORD INSERTION                 05280000
*      B'0100' = ',': INSERT COMMA AFTER WORD INSERTION                 05290000
*      B'0100' = '-': INSERT HYPHEN AFTER WORD INSERTION                05300000
*      B'0100' = '!': INSERT NOTHING AFTER WORD INSERTION               05310000
*      B'0010' = 'S': INSERT PLURAL "DOLLARS"                           05320000
*      B'0010' = ' ': INSERT SINGULAR "DOLLAR"                          05330000
*      B'0001' = 'S': INSERT PLURAL "CENTS"                             05340000
*      B'0001' = ' ': INSERT SINGULAR "CENT"                            05350000
*                                                                       05360000
R2       EQU   2                       REGISTER 2                       05370000
SECBAL   EQU   3                       SECONDARY INTERNAL BAL REGISTER  05380000
R3       EQU   3                       REGISTER 3                       05390000
PRIBAL   EQU   4                       PRIMARY INTERNAL BAL REGISTER    05400000
INREG    EQU   5                       INPUT FIELD POINTER              05410000
OUTREG   EQU   6                       OUTPUT FIELD POINTER             05420000
WORDREG  EQU   7                       LITERAL WORD POINTER             05430000
TABREG   EQU   7                       WORD LOOKUP TABLE BASE           05440000
R8       EQU   8                       REGISTER 8                       05450000
DIGREG   EQU   9                       DIGIT                            05460000
WLREG    EQU   9                       WORD LENGTH                      05470000
TELENREG EQU   10                      ENTRY LENGTH                     05480000
R11      EQU   11                      REGISTER 11                      05490000
BASE     EQU   12                      BASE REGISTER                    05500000
R14      EQU   14                      REGISTER 14                      05510000
R15      EQU   15                      REGISTER 15                      05520000
         END                                                            05530000
./ ENDUP                                                                00100000
%%                                                                      00110000
//                                                                      00120000
